Attribute VB_Name = "modCommon"
Option Explicit

' +-----------------------------------------------------------+
' | Common Controls Replacement :: modCommonControls          |
' +-----------------------------------------------------------+
' |   Autor(s): Peter Krner, Christoph von Wittich           |
' +-----------------------------------------------------------+
' |   Last Updated: 24. Februar 2004                          |
' +-----------------------------------------------------------+

Public Const ES_NUMBER As Long = &H2000&
Public Const GWL_STYLE As Long = -16
Public Const GWL_WNDPROC As Long = -4
Public Const GWL_HWNDPARENT = -8
Private Const CLR_INVALID As Long = &HFFFF&

Public Const SW_HIDE As Long = 0
Public Const SW_SHOWNOACTIVATE As Long = 4
Public Const SW_SHOW = 5
Public Const SW_RESTORE = 9

Private Type DLLVERSIONINFO
    cbSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformID As Long
End Type

'uxTheme.dll
Public Declare Function GetThemeSysColor Lib "uxtheme.dll" (ByVal hTheme As Long, ByVal iColorId As Long) As Long
Public Declare Function OpenThemeData Lib "uxtheme.dll" (ByVal hwnd As Long, ByVal pszClassList As Long) As Long
Public Declare Function CloseThemeData Lib "uxtheme.dll" (ByVal hTheme As Long) As Long

Private Declare Function ActivateWindowTheme Lib "uxtheme.dll" Alias "SetWindowTheme" (ByVal hwnd As Long, Optional ByVal pszSubAppName As Long = 0, Optional ByVal pszSubIdList As Long = 0) As Long
Private Declare Function DeactivateWindowTheme Lib "uxtheme.dll" Alias "SetWindowTheme" (ByVal hwnd As Long, Optional ByRef pszSubAppName As String = " ", Optional ByRef pszSubIdList As String = " ") As Long
Private Declare Function IsThemeActive Lib "uxtheme.dll" () As Boolean

'user32.dll
Public Declare Function GetParent Lib "user32.dll" (ByVal hwnd As Long) As Long
Public Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long

'comctl32.dll
Private Declare Function GetComctl32VersionInfo Lib "comctl32.dll" Alias "DllGetVersion" (ByRef lpDllVersionInfoStruct As DLLVERSIONINFO) As Long

'kernel32.dll
Private Declare Function GetModuleHandle Lib "kernel32.dll" Alias "GetModuleHandleA" (ByVal lpModuleName As String) As Long
Private Declare Function LoadLibrary Lib "kernel32.dll" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32.dll" (ByVal hLibModule As Long) As Long
Private Declare Function GetProcAddress Lib "kernel32.dll" (ByVal hModule As Long, ByVal lpProcName As String) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal nDest As Long, ByVal nSrc As Long, ByVal Length As Long)
Private Declare Function GetVersion Lib "kernel32.dll" () As Long

'oleaut32.dll
Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, ByRef lColorRef As Long) As Long

'Modules
Private Const ccModuleName = "comctl32.dll"
Private Const uxThemeModuleName = "uxtheme.dll"

'-> Local Variables
Private sCCtl32Ver As String

'--> Public Procedures

'Code von vbVision:
'Diese Funktion berprft, ob die angegebene Function von einer DLL
' exportiert wird.
Public Function IsFunctionExported(ByVal sFunction As String, ByVal sModule As String) As Boolean
    Dim hMod As Long, bLibLoaded As Boolean
    
    'Handle der DLL erhalten
    hMod = GetModuleHandle(sModule)
    If hMod = 0 Then 'Falls DLL nicht registriert ...
        hMod = LoadLibrary(sModule) 'DLL in den Speicher laden.
        If hMod Then bLibLoaded = True
    End If
    
    If CBool(hMod) Then
        IsFunctionExported = CBool(GetProcAddress(hMod, sFunction))
    End If
    
    If bLibLoaded Then Call FreeLibrary(hMod)
End Function

Public Function GetLibaryVersion() As String
    Dim DllVersion As DLLVERSIONINFO
    
    GetLibaryVersion = "0.0.000"
    
    If Not IsFunctionExported("DllGetVersion", ccModuleName) Then Exit Function
    
    DllVersion.cbSize = LenB(DllVersion)
    Call GetComctl32VersionInfo(DllVersion)
    
    GetLibaryVersion = CStr(DllVersion.dwMajorVersion) & "." & CStr(DllVersion.dwMinorVersion) & "." & CStr(DllVersion.dwBuildNumber)
End Function

Public Function CheckVer(ByVal sVer As String) As Boolean
    If Len(sCCtl32Ver) = 0 Then sCCtl32Ver = GetLibaryVersion
    CheckVer = sCCtl32Ver >= sVer
End Function

Public Function MAKELONG(ByVal wLow As Integer, ByVal wHi As Integer) As Long
    MAKELONG = (wHi * &H10000) + wLow
End Function

Public Sub SPLITLONG(ByRef wLow As Integer, ByRef wHi As Integer, ByVal lSource As Long)
    Call CopyMemory(VarPtr(wLow), VarPtr(lSource), 2)
    Call CopyMemory(VarPtr(wHi), VarPtr(lSource) + 2, 2)
End Sub

Public Function TranslateColor(ByVal oClr As OLE_COLOR, Optional hPal As Long = 0) As Long
    If OleTranslateColor(oClr, hPal, TranslateColor) Then TranslateColor = CLR_INVALID
End Function

Public Function GetTopParent(ByVal lControlHanldle As Long) As Long
    Dim lParent As Long
    lParent = lControlHanldle
    
    Do While lParent <> 0
        GetTopParent = lParent
        lParent = GetParent(lParent)
    Loop
End Function

Public Sub SetTheme(ByVal ControlHandle As Long, ByVal State As Boolean)
    If IsFunctionExported("EnableTheming", uxThemeModuleName) Then
        If State Then
            Call ActivateWindowTheme(ControlHandle)
        Else
            Call DeactivateWindowTheme(ControlHandle)
        End If
    End If
End Sub

Public Function ThemeActive() As Boolean
    If IsFunctionExported("IsThemeActive", uxThemeModuleName) Then
        ThemeActive = IsThemeActive
    End If
End Function

Public Function IsUnicodeSupported() As Boolean
   IsUnicodeSupported = ((GetVersion() And &H80000000) = 0)
End Function

