VERSION 5.00
Begin VB.UserControl CommonDialog 
   CanGetFocus     =   0   'False
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   495
   InvisibleAtRuntime=   -1  'True
   Picture         =   "CommonDialog.ctx":0000
   ScaleHeight     =   480
   ScaleWidth      =   495
   ToolboxBitmap   =   "CommonDialog.ctx":0C42
End
Attribute VB_Name = "CommonDialog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'################################################################################
' Modul        : CommonDialog
' Beschreibung : Ersatz fr das CommonDialog.ocx

'
' Erstellt von : Christoph von Wittich
' Erstellt am  : Montag, 4. Mai 2004
'
' Copyright (C) 2002-2004 bei Christoph von Wittich, alle Rechte vorbehalten.
' Kontakt: Christoph@ActiveVB.de


Private Const LOGPIXELSY As Long = 90
Private Const LF_FACESIZE As Long = 32
Private Const CCHDEVICENAME As Long = 32
Private Const CCHFORMNAME As Long = 32

Private Const SCREEN_FONTTYPE As Long = &H2000
Private Const GMEM_ZEROINIT As Long = &H40
Private Const GMEM_MOVEABLE As Long = &H2
Private Const MAX_PATH As Long = 260

Private Type PrintDlg
    lStructSize As Long
    hwndOwner As Long
    hDevMode As Long
    hDevNames As Long
    hdc As Long
    pFlags As Long
    nFromPage As Integer
    nToPage As Integer
    nMinPage As Integer
    nMaxPage As Integer
    nCopies As Integer
    hInstance As Long
    lCustData As Long
    lpfnPrintHook As Long
    lpfnSetupHook As Long
    lpPrintTemplateName As String
    lpSetupTemplateName As String
    hPrintTemplate As Long
    hSetupTemplate As Long
End Type

Private Type DevMode
    dmDeviceName As String * CCHDEVICENAME
    dmSpecVersion As Integer
    dmDriverVersion As Integer
    dmSize As Integer
    dmDriverExtra As Integer
    dmFields As Long
    dmOrientation As Integer
    dmPaperSize As Integer
    dmPaperLength As Integer
    dmPaperWidth As Integer
    dmScale As Integer
    dmCopies As Integer
    dmDefaultSource As Integer
    dmPrintQuality As Integer
    dmColor As Integer
    dmDuplex As Integer
    dmYResolution As Integer
    dmTTOption As Integer
    dmCollate As Integer
    dmFormName As String * CCHFORMNAME
    dmUnusedPadding As Integer
    dmBitsPerPel As Integer
    dmPelsWidth As Long
    dmPelsHeight As Long
    dmDisplayFlags As Long
    dmDisplayFrequency As Long
End Type

Private Type LogFont
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE) As Byte
End Type

Private Type ChooseFont
    lStructSize As Long
    hwndOwner As Long
    hdc As Long
    lpLogFont As Long
    iPointSize As Long
    fFlags As Long
    rgbColors As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
    hInstance As Long
    lpszStyle As String
    nFontType As Integer
    MISSING_ALIGNMENT As Integer
    nSizeMin As Long
    nSizeMax As Long
End Type
      
Private Type ChooseColor
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As Long
    ccFlags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Private Type OpenFileName
    lStructSize As Long
    hwndOnwer As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As Long
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As Long
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    nFlags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
End Type

Public Enum ComDlgActions
    cdlShowOpen = 1
    cdlShowSave = 2
    cdlShowColor = 3
    cdlShowFont = 4
    cdlShowPrinter = 5
    cdlShowHelp = 6
End Enum

Public Enum dlgFlags
    cdlPDNoChangeDir = &H8
    cdlPDShowhelp = &H10
    cdlPDAllowMultiselect = &H200
    cdlPDPathMustExist = &H800
    cdlOFNFileMustExist = &H1000
    cdlPDNoNetworkButton = &H20000
    cdlPDNoLongNames = &H40000
    cdlPDLongNames = &H200000
    cdlPDHideReadOnly = &H4
    cdlPDExplorer = &H80000
    cdlCCRGBInit = &H1
    cdlPD_Selection = &H1
    cdlPD_CurrentPage = &H400000
    cdlCCFullOpen = &H2
    cdlCCAnyColor = &H100
    cdlPDDisablePrintToFile = &H80000
    cdlPDReturnDC = &H100
    cdlPDReturnIC = &H200
    cdlPDAllPages = &H0
    cdlPDPrintSetup = &H40
    cdlCFEffects = &H100&
    cdlCFScreenFonts = &H1
    cdlCFPrinterFonts = &H2
    cdlCFBoth = &H3
End Enum

Public Enum dlgOrientation
    cdlLandscape = 0
    cdlPortrait = 1
End Enum

Public Enum dlgHelpCommands
    cdlHelpCommand = &H102&
    cdlHelpContents = &H3&
    cdlHelpContentsHW4X = &HB
    cdlHelpContext = &H1&
    cdlHelpContextPopup = &H8&
    cdlHelpForceFile = &H9&
    cdlHelpHelpOnHelp = &H4&
    cdlHelpIndex = &H3&
    cdlHelpKey = &H101&
    cdlHelpPartialKey = &H105&
    cdlHelpQuit = &H2&
    cdlHelpSetContents = &H5&
    cdlHelpSetIndex = &H5&
    cdlHelpSearch = 261
End Enum

Public Orientation As dlgOrientation
Public Filter As String
Public FileName As String
Public FileTitle As String
Attribute FileTitle.VB_VarMemberFlags = "400"
Public Color As OLE_COLOR
Public CancelError As Boolean
Public DialogTitle As String
Public DefaultExt As String
Public InitDir As String
Public Tag As String
Public FontName As String
Public flags As dlgFlags
Public FilterIndex As Long
Public HelpFile As String
Public HelpCommand As dlgHelpCommands
Public Copies As Integer
Public FromPage As Integer
Public ToPage As Integer
Public Min As Integer
Public Max As Integer
Public DeviceName As String
Attribute DeviceName.VB_VarMemberFlags = "400"
Public FontBold As Boolean
Public FontItalic As Boolean
Public FontSize As Integer
Public FontUnderLine As Boolean
Public FontStrikeThru As Boolean
Public PrinterDefault As Boolean
Public HelpContext As Long
Public MaxFileSize As Integer
Attribute MaxFileSize.VB_VarMemberFlags = "400"

'-----------------------------------------------------------
' Windows API-Deklarationen (ComDlg32)
'-----------------------------------------------------------
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenFileName As OpenFileName) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenFileName As OpenFileName) As Long
Private Declare Function ChooseFontDlg Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As ChooseFont) As Long
Private Declare Function ChooseColorDlg Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As ChooseColor) As Long
Private Declare Function PrintDlg Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintDlg As PrintDlg) As Long

'-----------------------------------------------------------
' Windows API-Deklarationen (User32)
'-----------------------------------------------------------
Private Declare Function WinHelp Lib "user32.dll" Alias "WinHelpA" (ByVal hwnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long
Private Declare Function GetActiveWindow Lib "user32.dll" () As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long

'-----------------------------------------------------------
' Windows API-Deklarationen (Kernel32)
'-----------------------------------------------------------
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'-----------------------------------------------------------
' Windows API-Deklarationen (GDI32)
'-----------------------------------------------------------
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long

'-----------------------------------------------------------
' SUB: ShowFont
'
' Zeigt den Schrift-Auswahl Dialog an
'-----------------------------------------------------------
Public Sub ShowFont()
    Dim udtChooseFont As ChooseFont, _
        udtLogFont As LogFont, _
        strFaceName As String, _
        lngResult As Long
 
    udtChooseFont.lpLogFont = VarPtr(udtLogFont)
    udtChooseFont.hdc = GetDC(GetActiveWindow)
    udtChooseFont.lStructSize = Len(udtChooseFont)
    udtChooseFont.hwndOwner = GetActiveWindow
    udtChooseFont.fFlags = flags
    udtChooseFont.nFontType = SCREEN_FONTTYPE
    udtChooseFont.rgbColors = Color
    lngResult = ChooseFontDlg(udtChooseFont)
 
    If (lngResult <> 0) Then
        strFaceName = StrConv(udtLogFont.lfFaceName, vbUnicode)
        Me.FontSize = Abs(udtLogFont.lfHeight * (72 / GetDeviceCaps(GetDC(GetActiveWindow), LOGPIXELSY)))
        Me.FontName = Left$(strFaceName, InStr(strFaceName, Chr$(0)) - 1)
        Me.FontItalic = CBool(Asc(udtLogFont.lfItalic) = 49)
        Me.FontStrikeThru = CBool(Asc(udtLogFont.lfStrikeOut) = 49)
        Me.FontUnderLine = CBool(Asc(udtLogFont.lfUnderline) = 49)
        Me.FontBold = CBool(Asc(udtLogFont.lfWeight) = 55)
        Color = udtChooseFont.rgbColors
    Else
        If (CancelError) Then _
            Err.Raise 32755, "ShowFont", "Abbrechen wurde gewhlt"
    End If
    
    Me.FontBold = Not CBool((udtLogFont.lfWeight < 500))

End Sub

'-----------------------------------------------------------
' SUB: ShowPrinter
'
' Zeigt den Drucken Dialog an
'-----------------------------------------------------------
Public Sub ShowPrinter()
    Dim lngAddress As Long, _
        lngResult As Long, _
        udtPrintDialog As PrintDlg, _
        udtDevMode As DevMode
 
    udtDevMode.dmDeviceName = Me.DeviceName
    udtDevMode.dmOrientation = Orientation
    
    With udtPrintDialog
        .lStructSize = Len(udtPrintDialog)
        .hwndOwner = GetActiveWindow
        .pFlags = flags
        .nCopies = Copies
        .nToPage = ToPage
        .nFromPage = FromPage
        .nMaxPage = Max
        .nMinPage = Min
    End With
    
    lngResult = PrintDlg(udtPrintDialog)
    
    If lngResult <> 0 Then
        lngAddress = GlobalLock(udtPrintDialog.hDevMode)
        Call CopyMemory(udtDevMode, ByVal lngAddress, Len(udtDevMode))
        If udtPrintDialog.hdc <> 0 Then Call DeleteDC(udtPrintDialog.hdc)
        If udtPrintDialog.hDevNames <> 0 Then Call GlobalFree(udtPrintDialog.hDevNames)
        Call GlobalUnlock(udtPrintDialog.hDevMode)
        Call GlobalFree(udtPrintDialog.hDevMode)
        Me.DeviceName = Left$(udtDevMode.dmDeviceName, InStr(udtDevMode.dmDeviceName, Chr$(0)) - 1)
        Orientation = udtDevMode.dmOrientation
        Copies = udtPrintDialog.nCopies
        FromPage = udtPrintDialog.nFromPage
        ToPage = udtPrintDialog.nToPage
        If (Me.PrinterDefault) Then
            Dim Pr As Printer
            For Each Pr In Printers
                If Pr.DeviceName = Me.DeviceName Then Set Printer = Pr
            Next Pr
        End If
    Else
        If (CancelError) Then _
            Err.Raise 32755, "CommonDialog::ShowColor", "Abbrechen wurde gewhlt"
    End If
    
End Sub

'-----------------------------------------------------------
' SUB: ShowColor
'
' Zeigt den Farb-Auswahl Dialog an
'-----------------------------------------------------------
Public Sub ShowColor()
    Dim udtChooseColor As ChooseColor, _
        hMem As Long, pMem As Long, _
        lngCustomColors(0 To 15) As Long, _
        lngCounter As Long, lngRetVal As Long
 
    For lngCounter = 0 To 15
        lngCustomColors(lngCounter) = QBColor(15)
    Next lngCounter
 
    hMem = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, 64)
    pMem = GlobalLock(hMem)
    Call CopyMemory(ByVal pMem, lngCustomColors(0), 64)
    udtChooseColor.lStructSize = Len(udtChooseColor)
    udtChooseColor.hwndOwner = GetActiveWindow
    udtChooseColor.hInstance = 0
    udtChooseColor.rgbResult = Color
    udtChooseColor.lpCustColors = pMem
    udtChooseColor.ccFlags = flags
    udtChooseColor.lCustData = 0
    udtChooseColor.lpfnHook = 0
    udtChooseColor.lpTemplateName = ""
    lngRetVal = ChooseColorDlg(udtChooseColor)
    
    If (lngRetVal <> 0) Then
        CopyMemory lngCustomColors(0), ByVal pMem, 64
        Color = udtChooseColor.rgbResult
    Else
        If (CancelError) Then _
            Err.Raise 32755, "CommonDialog::ShowColor", "Abbrechen wurde gewhlt"
    End If
    
    Call GlobalUnlock(hMem)
    Call GlobalFree(pMem)

End Sub

'-----------------------------------------------------------
' SUB: ShowHelp
'
' Zeigt eine Windows-Hilfedatei an
'-----------------------------------------------------------
Public Sub ShowHelp()
    If (Me.HelpCommand = 0) Then _
        Me.HelpCommand = cdlHelpContents
        
    If (Len(Me.HelpFile) = 0) Then _
        Me.HelpFile = App.HelpFile
        
    Call WinHelp(GetActiveWindow, Me.HelpFile, Me.HelpCommand, Me.HelpContext)
End Sub

'-----------------------------------------------------------
' FUNCTION: ShowOpen
'
' Zeigt den ffnen Dialog an
'-----------------------------------------------------------
Public Function ShowOpen() As String
    Dim udtOpenFileName As OpenFileName, _
        lngCounter As Long
 
    FileName = Me.FileName + Chr$(0) + Space$(MAX_PATH)
    
    If IsMissing(Filter) Then _
        Filter = "Alle Dateien (*.*)|*.*"
  
    If (Len(InitDir) = 0) Then _
        InitDir = CurDir$
 
    If Right$(Filter, 1) <> "|" Then _
        Filter = Filter & "|"
    
    For lngCounter = 1 To Len(Filter)
        If Mid$(Filter, lngCounter, 1) = "|" Then Mid$(Filter, lngCounter, 1) = Chr$(0)
    Next lngCounter
 
    Filter = Filter & Chr$(0) & Chr$(0)
    With udtOpenFileName
        .lStructSize = Len(udtOpenFileName)
        .hwndOnwer = GetActiveWindow
        .lpstrFile = FileName
        .nMaxFile = MAX_PATH
        .lpstrFilter = Filter
        .nFilterIndex = FilterIndex
        .nMaxFile = Me.MaxFileSize
        If Not IsMissing(DialogTitle) Then _
            .lpstrTitle = DialogTitle
        .lpstrInitialDir = InitDir
        .nFlags = flags
    End With
 
    If (GetOpenFileName(udtOpenFileName) <> 0) Then
        ShowOpen = Left$(udtOpenFileName.lpstrFile, InStr(udtOpenFileName.lpstrFile, Chr(0)) - 1)
        Me.FileName = Left$(udtOpenFileName.lpstrFile, InStr(udtOpenFileName.lpstrFile, Chr(0)) - 1)
        Me.FileTitle = Right$(Me.FileName, Len(Me.FileName) - InStrRev(Me.FileName, "\"))
        Me.FilterIndex = udtOpenFileName.nFilterIndex
        Me.MaxFileSize = udtOpenFileName.nMaxFile
    Else
        ShowOpen = ""
        Me.FileName = ""
        If (CancelError) Then _
            Err.Raise 32755, "CommonDialog::ShowOpen", "Abbrechen wurde gewhlt"
    End If

End Function

'-----------------------------------------------------------
' FUNCTION: ShowSave
'
' Zeigt den Speichern Dialog an
'-----------------------------------------------------------
Public Function ShowSave() As String
    Dim udtOpenFileName As OpenFileName, _
        lngCounter As Long, strExtension As String
 
    FileName = Me.FileName + Chr$(0) + Space$(MAX_PATH)
    
    If (IsMissing(Filter)) Then _
        Filter = "Alle Dateien (*.*)|*.*"
               
    If (Len(InitDir) = 0) Then _
        InitDir = CurDir$
 
    If (Right$(Filter, 1) <> "|") Then _
        Filter = Filter & "|"
        
    For lngCounter = 1 To Len(Filter)
        If Mid$(Filter, lngCounter, 1) = "|" Then _
            Mid$(Filter, lngCounter, 1) = Chr(0)
    Next lngCounter
 
    Filter = Filter & Chr$(0) & Chr$(0)
    With udtOpenFileName
        .lStructSize = Len(udtOpenFileName)
        .hwndOnwer = GetActiveWindow
        .lpstrFile = FileName
        .nMaxFile = MAX_PATH
        .nFilterIndex = FilterIndex
        .lpstrFilter = Filter
        .lpstrInitialDir = InitDir
        .nMaxFile = Me.MaxFileSize
        .nFlags = flags
    End With
 
    If GetSaveFileName(udtOpenFileName) <> 0 Then
        ShowSave = Left$(udtOpenFileName.lpstrFile, InStr(udtOpenFileName.lpstrFile, Chr(0)) - 1)
        Me.FileName = Left$(udtOpenFileName.lpstrFile, InStr(udtOpenFileName.lpstrFile, Chr(0)) - 1)
        Me.FileTitle = Right$(Me.FileName, Len(Me.FileName) - InStrRev(Me.FileName, "\"))
        Me.FilterIndex = udtOpenFileName.nFilterIndex
        Me.MaxFileSize = udtOpenFileName.nMaxFile
    Else
        ShowSave = ""
        Me.FileName = ""
        If (CancelError) Then _
            Err.Raise 32755, "CommonDialog::ShowSave", "Abbrechen wurde gewhlt"
    End If
    
    strExtension = Trim$(GetParam(Filter, 2 * FilterIndex, Chr$(0)))
    strExtension = Right$(strExtension, (Len(strExtension) - InStrRev(strExtension, ".")) + 1)
    
    If (Len(FileName) <= 3) Then _
        FileName = FileName & strExtension
    
    If (Len(FileName) <> 0) Then
        If Not Mid$(FileName, Len(FileName) - 3, 1) = "." Then _
            FileName = FileName & strExtension
        If Not Len(DefaultExt) = 0 Then
            If Not Left$(DefaultExt, 1) = "." Then _
                DefaultExt = "." + DefaultExt
            If Not Right$(FileName, Len(DefaultExt)) = DefaultExt Then
                ShowSave = ShowSave + DefaultExt
                Me.FileName = Me.FileName + DefaultExt
            End If
        End If
    End If
    
End Function

'-----------------------------------------------------------
' PROPERTY LET: Action
'
' Zeigt einen Dialog an (muss als Parameter bergeben werden)
'-----------------------------------------------------------
Property Let Action(cdlPDAction As ComDlgActions)
    Select Case cdlPDAction
        Case 1
            ShowOpen
        Case 2
            ShowSave
        Case 3
            ShowColor
        Case 4
            ShowFont
        Case 5
            ShowPrinter
        Case 6
            ShowHelp
    End Select
End Property

'-----------------------------------------------------------
' FUNCTION: GetParam
'
' Gibt einen Parameter/Wort eines Strings zurck
'-----------------------------------------------------------
Private Function GetParam(CmdLine As String, CmdNumber As Integer, Seperator As String) As String
    Dim strStart As Integer, Param As Integer
    Dim SepPos As Integer, SepPos2 As Integer
    Dim PTmp As String
    strStart = 1
    If Not Left$(CmdLine, Len(Seperator)) = Seperator Then CmdLine = Seperator & CmdLine
    Do Until CmdNumber = Param
        Param = Param + 1
        SepPos = InStr(strStart, CmdLine, Seperator)
        SepPos2 = InStr(SepPos + 1, CmdLine, Seperator)
        If SepPos2 = 0 Then SepPos2 = Len(CmdLine)
        PTmp = Mid$(CmdLine, SepPos + 1, SepPos2 - SepPos - 1)
        strStart = SepPos2
    Loop
    GetParam = PTmp
End Function

'-----------------------------------------------------------
' Property Get: Object
'
' Gibt die eigene Instanz zurck
'-----------------------------------------------------------
'FIXIT: 'Object' mit einem Datentyp mit frher Bindung deklarieren                         FixIT90210ae-R1672-R1B8ZE
Public Property Get Object() As Object
    Set Object = Me
End Property

'-----------------------------------------------------------
' SUB: UserControl_Initialize
'
' Initialisierung des Controls
' und festlegen der Standard Werte
'-----------------------------------------------------------
Private Sub UserControl_Initialize()
    Me.MaxFileSize = 260
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Me.CancelError = PropBag.ReadProperty("CancelError", False)
    Me.Color = PropBag.ReadProperty("Color", &H0&)
    Me.Copies = PropBag.ReadProperty("Copies", 1)
    Me.DefaultExt = PropBag.ReadProperty("DefaultExt", "")
    Me.DialogTitle = PropBag.ReadProperty("DialogTitle", "")
    Me.FileName = PropBag.ReadProperty("FileName", "")
    Me.Filter = PropBag.ReadProperty("Filter", "")
    Me.FilterIndex = PropBag.ReadProperty("FilterIndex", 0)
    Me.flags = PropBag.ReadProperty("Flags", 0)
    Me.FontBold = PropBag.ReadProperty("FontBold", False)
    Me.FontItalic = PropBag.ReadProperty("FontItalic", False)
    Me.FontStrikeThru = PropBag.ReadProperty("FontStrikeThru", False)
    Me.FontUnderLine = PropBag.ReadProperty("FontUnderLine", False)
    Me.FontName = PropBag.ReadProperty("FontName", "")
    Me.FromPage = PropBag.ReadProperty("FromPage", 1)
    Me.HelpCommand = PropBag.ReadProperty("HelpCommand", 0)
    Me.HelpContext = PropBag.ReadProperty("HelpContext", 0)
    Me.HelpFile = PropBag.ReadProperty("HelpFile", "")
    Me.InitDir = PropBag.ReadProperty("InitDir", "")
    Me.Min = PropBag.ReadProperty("Min", 1)
    Me.Max = PropBag.ReadProperty("Max", 1)
    Me.Orientation = PropBag.ReadProperty("Orientation", cdlPortrait)
    Me.PrinterDefault = PropBag.ReadProperty("PrinterDefault", False)
    Me.FontSize = PropBag.ReadProperty("FontSize", 8)
    Me.Tag = PropBag.ReadProperty("Tag", "")
    Me.ToPage = PropBag.ReadProperty("ToPage", 1)
End Sub

Private Sub UserControl_Resize()
    Call Size(495, 495)
End Sub

Public Sub About()
Attribute About.VB_UserMemId = -552
    Call MsgBox("CommonDialog Replacement" & vbNewLine & vbNewLine & "(C) 2003 Christoph von Wittich", vbInformation, "cCommonDialog")
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "CancelError", Me.CancelError, False
    PropBag.WriteProperty "Color", Me.Color, &H0&
    PropBag.WriteProperty "Copies", Me.Copies, 1
    PropBag.WriteProperty "DefaultExt", Me.DefaultExt, ""
    PropBag.WriteProperty "DialogTitle", Me.DialogTitle, ""
    PropBag.WriteProperty "FileName", Me.FileName, ""
    PropBag.WriteProperty "Filter", Me.Filter, ""
    PropBag.WriteProperty "FilterIndex", Me.FilterIndex, 0
    PropBag.WriteProperty "Flags", Me.flags, 0
    PropBag.WriteProperty "FontBold", Me.FontBold, False
    PropBag.WriteProperty "FontItalic", Me.FontItalic, False
    PropBag.WriteProperty "FontStrikeThru", Me.FontStrikeThru, False
    PropBag.WriteProperty "FontUnderLine", Me.FontUnderLine, False
    PropBag.WriteProperty "FontName", Me.FontName, ""
    PropBag.WriteProperty "FromPage", Me.FromPage, 1
    PropBag.WriteProperty "HelpCommand", Me.HelpCommand, 0
    PropBag.WriteProperty "HelpContext", Me.HelpContext, 0
    PropBag.WriteProperty "HelpFile", Me.HelpFile, ""
    PropBag.WriteProperty "InitDir", Me.InitDir, ""
    PropBag.WriteProperty "Min", Me.Min, 1
    PropBag.WriteProperty "Max", Me.Max, 1
    PropBag.WriteProperty "Orientation", Me.Orientation, cdlPortrait
    PropBag.WriteProperty "PrinterDefault", Me.PrinterDefault, False
    PropBag.WriteProperty "FontSize", Me.FontSize, 8
    PropBag.WriteProperty "Tag", Me.Tag, ""
    PropBag.WriteProperty "ToPage", Me.ToPage, 1
End Sub
