VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cRouter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_strGateway As String
Private m_lngPort As Long
Private m_strLocalIP As String
Private m_strPassword As String
Private m_bolCompleted As Boolean
Private m_strRetVal As String

Private Const WS_VERSION_REQD = &H101
Private Const WS_VERSION_MAJOR = WS_VERSION_REQD \ &H100 And &HFF&
Private Const WS_VERSION_MINOR = WS_VERSION_REQD And &HFF&
Private Const MIN_SOCKETS_REQD = 1
Private Const SOCKET_ERROR = -1
Private Const WSADescription_Len = 256
Private Const WSASYS_Status_Len = 128

Private Type HOSTENT
    hName As Long
    hAliases As Long
    hAddrType As Integer
    hLength As Integer
    hAddrList As Long
End Type

Private Type WSADATA
    wversion As Integer
    wHighVersion As Integer
    szDescription(0 To WSADescription_Len) As Byte
    szSystemStatus(0 To WSASYS_Status_Len) As Byte
    iMaxSockets As Integer
    iMaxUdpDg As Integer
    lpszVendorInfo As Long
End Type

Private Type PMIB_IPFORWARDROW
    dwForwardDest As Long
    dwForwardMask As Long
    dwForwardPolicy As Long
    dwForwardNextHop As Long
    dwForwardIfIndex As Long
    dwForwardType As Long
    dwForwardProto As Long
    dwForwardAge As Long
    dwForwardNextHopAS As Long
    dwForwardMetric1 As Long
    dwForwardMetric2 As Long
    dwForwardMetric3 As Long
    dwForwardMetric4 As Long
    dwForwardMetric5 As Long
End Type

Private Type PMIB_IPFORWARDTABLE
    dwNumEntries As Long
    table As PMIB_IPFORWARDROW
End Type

Private Declare Function GetIpForwardTable Lib "iphlpapi.dll" (ByRef pIpForwardTable As Any, ByRef pdwSize As Long, ByVal border As Long) As Long
Private Declare Function WSAStartup Lib "WSOCK32.DLL" (ByVal wVersionRequired As Integer, lpWSAData As WSADATA) As Long
Private Declare Function WSACleanup Lib "WSOCK32.DLL" () As Long
Private Declare Function gethostname Lib "WSOCK32.DLL" (ByVal hostname As String, ByVal HostLen As Long) As Long
Private Declare Function gethostbyname Lib "WSOCK32.DLL" (ByVal hostname As String) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (hpvDest As Any, ByVal hpvSource As Long, ByVal cbCopy As Long)
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Public Function ConfigureVirtualServer(Port As Long, Password As String, Optional RouterIP As String) As String
    
    If IsMissing(RouterIP) Then
        m_strGateway = "http://" & pGetGateway
    Else
        m_strGateway = RouterIP
    End If
    
    m_strLocalIP = pGetLocalIP
    m_strPassword = Password
    m_lngPort = Port
    m_bolCompleted = False
    
    If m_strLocalIP = "" Then
        ConfigureVirtualServer = "ERR_CANNOT_RETRIEVE_LOCAL_IP"
        Exit Function
    End If
    
    frmDummy.strURL = ""
    frmDummy.web.Navigate m_strGateway
    Do Until frmDummy.strURL <> "" Or m_bolCompleted
        DoEvents
    Loop
    Do Until m_bolCompleted
        DoEvents
        Call Document_Complete(frmDummy.strURL)
        Do Until frmDummy.strURL <> "" Or m_bolCompleted
            DoEvents
        Loop
    Loop
    Unload frmDummy
    ConfigureVirtualServer = m_strRetVal
End Function

Private Function Document_Complete(URL As String) As String
    Dim i As Long, j As Long
    Dim arrPorts() As String
    Dim bolAlreadyUsed As Boolean
    Dim lngFreeSlot As Long
    Dim strIPBlock1 As String
    Dim lngIPBlock2 As Long
    
    frmDummy.strURL = ""
    
    If Len(m_strGateway) > Len(URL) Then Exit Function
    
    If URL = m_strGateway & "/loginpserr.stm" Then
        If InStr(CStr(frmDummy.web.Document.body.innerhtml), "Incorrect Password") > 0 Then
            m_strRetVal = "ERR_WRONG_PASSWORD"
            m_bolCompleted = True
            Exit Function
        End If
    End If
    
    If URL = m_strGateway & "/" Then
        If InStr(CStr(frmDummy.web.Document.body.innerhtml), "Telekom AG") < 1 Then
            m_strRetVal = "ERR_WRONG_DEVICE"
            m_bolCompleted = True
            Exit Function
        End If
        frmDummy.web.Document.Forms(0).pws.Value = m_strPassword
        frmDummy.web.Document.Forms(0).submit
    End If

    If URL = m_strGateway & "/index.stm" Then
        frmDummy.web.Navigate m_strGateway & "/nat_v.stm"
    End If

    lngFreeSlot = -1
    If URL = m_strGateway & "/nat_v.stm" Then
        strIPBlock1 = Left$(m_strLocalIP, InStrRev(m_strLocalIP, "."))
        lngIPBlock2 = CLng(Right$(m_strLocalIP, Len(m_strLocalIP) - InStrRev(m_strLocalIP, ".")))
        For i = 1 To 20
            arrPorts() = Split(CStr(frmDummy.web.Document.tf0.elements(getElementsByFieldName(frmDummy.web.Document.tf0, "pport" & i)).Value), ",")
            For j = 0 To UBound(arrPorts())
                If IsInPortRange(arrPorts(j), m_lngPort) Then
                    m_strRetVal = "ERR_PORT_IN_USE:" & strIPBlock1 & CStr(frmDummy.web.Document.tf0.elements(getElementsByFieldName(frmDummy.web.Document.tf0, "pip" & i)).Value)
                    m_bolCompleted = True
                    bolAlreadyUsed = True
                    Exit Function
                End If
            Next j
            If CStr(frmDummy.web.Document.tf0.elements(getElementsByFieldName(frmDummy.web.Document.tf0, "pport" & i)).Value) = "" And lngFreeSlot = -1 Then
                lngFreeSlot = i
            End If
        Next i
        
        If Not bolAlreadyUsed Then
            If lngFreeSlot = -1 Then
                m_strRetVal = "ERR_NO_SLOTS_AVAILABLE"
                m_bolCompleted = True
                Exit Function
            Else
                frmDummy.web.Document.tf0.elements(getElementsByFieldName(frmDummy.web.Document.tf0, "pport" & lngFreeSlot)).Value = 1500
                frmDummy.web.Document.tf0.elements(getElementsByFieldName(frmDummy.web.Document.tf0, "puport" & lngFreeSlot)).Value = 1500
                frmDummy.web.Document.tf0.elements(getElementsByFieldName(frmDummy.web.Document.tf0, "pip" & lngFreeSlot)).Value = lngIPBlock2
                frmDummy.web.Document.parentWindow.execScript "javascript:document.forms[0].submit()"
            End If
        End If
        m_strRetVal = "SUCCESS"
        m_bolCompleted = True
    End If
End Function

Private Function getElementsByFieldName(target_form As Object, field As String) As Long
    Dim i As Long
    If (target_form Is Nothing Or field = "") Then
        getElementsByFieldName = -1
        Exit Function
    End If
    For i = 0 To target_form.Length - 1
        If (target_form.elements(i).Name = field) Then
            getElementsByFieldName = i
            Exit Function
        End If
    Next i
    getElementsByFieldName = -1
End Function

Private Function IsInPortRange(Ports As String, myPort As Long) As Boolean
    Dim lngLowerBound As Long
    Dim lngUpperBound As Long
    If InStr(Ports, "-") > 0 Then
        lngLowerBound = CLng(Left$(Ports, InStr(Ports, "-") - 1))
        lngUpperBound = CLng(Right$(Ports, Len(Ports) - InStr(Ports, "-")))
        If myPort >= lngLowerBound And myPort <= lngUpperBound Then
            IsInPortRange = True
        End If
    Else
        IsInPortRange = CBool(myPort = CLng(Ports))
    End If
End Function

Private Sub Class_Initialize()
    pSocketsInitialize
End Sub

Private Sub Class_Terminate()
    pSocketsCleanup
End Sub

Private Sub pSocketsCleanup()
    Dim lReturn As Long
    lReturn = WSACleanup()
    If lReturn <> 0 Then
        'MsgBox "Socket error " & Trim$(Str$(lReturn)) & " occurred in Cleanup "
    End If
End Sub

Private Sub pSocketsInitialize()
    Dim WSAD As WSADATA
    Dim iReturn As Integer
    Dim sLowByte As String, sHighByte As String, sMsg As String
    iReturn = WSAStartup(WS_VERSION_REQD, WSAD)
    If iReturn <> 0 Then
        'MsgBox "Winsock.dll is not responding."
        Exit Sub
    End If
    If pLOBYTE(WSAD.wversion) < WS_VERSION_MAJOR Or (pLOBYTE(WSAD.wversion) = _
        WS_VERSION_MAJOR And pHIBYTE(WSAD.wversion) < WS_VERSION_MINOR) Then
        sHighByte = Trim$(Str$(pHIBYTE(WSAD.wversion)))
        sLowByte = Trim$(Str$(pLOBYTE(WSAD.wversion)))
        sMsg = "Windows Sockets version " & sLowByte & "." & sHighByte
        sMsg = sMsg & " is not supported by winsock.dll "
        'MsgBox sMsg
        Exit Sub
    End If
    If WSAD.iMaxSockets < MIN_SOCKETS_REQD Then
        sMsg = "This application requires a minimum of "
        sMsg = sMsg & Trim$(Str$(MIN_SOCKETS_REQD)) & " supported sockets."
        Exit Sub
    End If
End Sub

Private Function pHIBYTE(ByVal wParam As Integer) As Byte
    pHIBYTE = wParam \ &H100 And &HFF&
End Function

Private Function pLOBYTE(ByVal wParam As Integer) As Byte
    pLOBYTE = wParam And &HFF&
End Function

Private Function pGetLocalIP() As String
    Dim hostname As String * 256
    Dim hostent_addr As Long
    Dim host As HOSTENT
    Dim hostip_addr As Long
    Dim temp_ip_address() As Byte
    Dim i As Integer
    Dim ip_address As String
    If gethostname(hostname, 256) = SOCKET_ERROR Then
      '  MsgBox "Windows Sockets error " & Str(WSAGetLastError())
        Exit Function
    Else
        hostname = Trim$(hostname)
    End If
    hostent_addr = gethostbyname(hostname)
    If hostent_addr = 0 Then
'        MsgBox "Winsock.dll is not responding."
        Exit Function
    End If
    RtlMoveMemory host, hostent_addr, LenB(host)
    RtlMoveMemory hostip_addr, host.hAddrList, 4
    Do
        ReDim temp_ip_address(1 To host.hLength)
        RtlMoveMemory temp_ip_address(1), hostip_addr, host.hLength
        For i = 1 To host.hLength
            ip_address = ip_address & temp_ip_address(i) & "."
        Next
        ip_address = Mid$(ip_address, 1, Len(ip_address) - 1)
        pGetLocalIP = ip_address
        ip_address = ""
        host.hAddrList = host.hAddrList + LenB(host.hAddrList)
        RtlMoveMemory hostip_addr, host.hAddrList, 4
    Loop While (hostip_addr <> 0)
End Function

Private Function pLongIP2Dotted(ByVal LongIP As String) As String
    Dim i As Integer
    Dim num As Byte
    On Error GoTo ErrLongIP2Dotted
    
    If LongIP = "" Then Err.Raise vbObjectError + 1
    If LongIP < 0 Then LongIP = 4294967296# + LongIP
    If LongIP < 0 Then Err.Raise vbObjectError + 1
    For i = 3 To 0 Step -1
        num = Int(LongIP / 256 ^ (i))
        LongIP = LongIP - (num * 256 ^ (i))
        pLongIP2Dotted = num & "." & pLongIP2Dotted
    Next
    pLongIP2Dotted = Left$(pLongIP2Dotted, Len(pLongIP2Dotted) - 1)
    Exit Function
ErrLongIP2Dotted:
    pLongIP2Dotted = "0.0.0.0"
End Function

Private Function pGetGateway() As String
    Dim Siz As Long, x As Long
    Dim IPTab As PMIB_IPFORWARDTABLE
    Dim IPRow As PMIB_IPFORWARDROW
    Dim bBuffer() As Byte
    x = GetIpForwardTable(ByVal 0&, Siz, False)
    If x <> 0 And x <> 122 Then Exit Function
    ReDim bBuffer(Siz)
    If GetIpForwardTable(bBuffer(0), Siz, False) = 0 Then
        CopyMemory IPTab, bBuffer(0), Len(IPTab)
        Siz = IPTab.dwNumEntries - 1
        For x = 0 To Siz
            CopyMemory IPTab, bBuffer(x * (Len(IPTab) - 4)), Len(IPTab)
            If IPTab.table.dwForwardDest = 0 Then
                IPRow = IPTab.table
                pGetGateway = pLongIP2Dotted(IPTab.table.dwForwardNextHop)
            End If
        Next
    End If
End Function
