VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cRouter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Type RouterInfo
    Model As String
    IP As String
    URL As String
    ConfigObj As String
End Type

Private Type PMIB_IPFORWARDROW
    dwForwardDest As Long
    dwForwardMask As Long
    dwForwardPolicy As Long
    dwForwardNextHop As Long
    dwForwardIfIndex As Long
    dwForwardType As Long
    dwForwardProto As Long
    dwForwardAge As Long
    dwForwardNextHopAS As Long
    dwForwardMetric1 As Long
    dwForwardMetric2 As Long
    dwForwardMetric3 As Long
    dwForwardMetric4 As Long
    dwForwardMetric5 As Long
End Type

Private Type PMIB_IPFORWARDTABLE
    dwNumEntries As Long
    table As PMIB_IPFORWARDROW
End Type

Private Declare Function GetIpForwardTable Lib "iphlpapi.dll" (ByRef pIpForwardTable As Any, ByRef pdwSize As Long, ByVal border As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

Private Internet As New cInet

Public Function DetectRouter(Optional strRouterIP) As RouterInfo
    Dim strBuffer As String
    Dim strGateway As String
    Dim strLineBuffer As String
    Dim arrList() As String
    Dim RI As RouterInfo
    Dim hFile As Long
    If IsMissing(strRouterIP) Then
        strGateway = "http://" & GetGateway
    Else
        strGateway = strRouterIP
    End If
    RI.IP = GetGateway
    RI.Model = "Unknown"
    RI.URL = strGateway
    RI.ConfigObj = "null"
    If RI.IP = "0.0.0.0" Then
        RI.Model = ""
        Exit Function
    End If
    strBuffer = Internet.OpenURL(strGateway, icString)
    hFile = FreeFile
    Open IIf(Right$(App.Path, 1) = "\", App.Path, App.Path & "\") & "router.conf" For Input As #hFile
    Do Until EOF(hFile)
        Line Input #hFile, strLineBuffer
        arrList = Split(strLineBuffer, ";")
        If UBound(arrList()) > 1 Then
            If InStr(strBuffer, arrList(2)) > 0 Then
                RI.Model = arrList(0)
                RI.ConfigObj = arrList(1)
            End If
        End If
    Loop
    Close #hFile
    DetectRouter = RI
End Function

Private Function pLongIP2Dotted(ByVal LongIP As Variant) As String
    Dim i As Integer
    Dim num As Byte
    On Error GoTo ErrLongIP2Dotted
    If LongIP = "" Then Err.Raise vbObjectError + 1
    If LongIP < 0 Then LongIP = 4294967296# + LongIP
    If LongIP < 0 Then Err.Raise vbObjectError + 1
    For i = 3 To 0 Step -1
        num = Int(LongIP / 256 ^ (i))
        LongIP = LongIP - (num * 256 ^ (i))
        pLongIP2Dotted = num & "." & pLongIP2Dotted
    Next
    pLongIP2Dotted = Left$(pLongIP2Dotted, Len(pLongIP2Dotted) - 1)
    Exit Function
ErrLongIP2Dotted:
    pLongIP2Dotted = "0.0.0.0"
End Function

Public Function GetGateway() As String
    Dim Siz As Long, x As Long
    Dim IPTab As PMIB_IPFORWARDTABLE
    Dim IPRow As PMIB_IPFORWARDROW
    Dim bBuffer() As Byte
    x = GetIpForwardTable(ByVal 0&, Siz, False)
    If x <> 0 And x <> 122 Then Exit Function
    ReDim bBuffer(Siz)
    If GetIpForwardTable(bBuffer(0), Siz, False) = 0 Then
        CopyMemory IPTab, bBuffer(0), Len(IPTab)
        Siz = IPTab.dwNumEntries - 1
        For x = 0 To Siz
            CopyMemory IPTab, bBuffer(x * (Len(IPTab) - 4)), Len(IPTab)
            If IPTab.table.dwForwardDest = 0 Then
                IPRow = IPTab.table
                GetGateway = pLongIP2Dotted(IPTab.table.dwForwardNextHop)
            End If
        Next
    End If
End Function

