Attribute VB_Name = "modSettings"
Option Explicit

Private m_Settings As CIni
' Aufbau der Strings: Parametername|Displayname jeweils durch Komma getrennt
Public Const strSounds As String = "GotMsg|Nachricht,GotCode|SourceCode,GotFile|Datei,GotNewUsr|Neuer Benutzer"
Public Const strStates As String = "Break|Pause,Away|Abwesend,LongAway|Lange abwesend,Busy|Beschftigt"
'----------------------------------------------------

Public Sub LoadSettings(Optional FileName As String)
    Set m_Settings = New CIni
    
    If CBool(LenB(FileName)) Then _
        m_Settings.IniPath = FileName
End Sub

Public Function GetSetting(Section As String, Key As String) As String
    On Local Error Resume Next
    GetSetting = m_Settings.IniRead(Section, Key)
    
    If LenB(GetSetting) = 0 Then
        GetSetting = RestoreDefault(Section & "\" & Key)
        Call m_Settings.IniWrite(Section, Key, GetSetting)
    End If
    
End Function

Public Property Get FileTransferPath() As String
    FileTransferPath = m_Settings.FileTransferPath
End Property

Public Property Get UserPath() As String
    UserPath = m_Settings.UserPath
End Property
'----------------------------------------------------

Public Sub WriteSetting(Section As String, Key As String, Value As String)
   If LenB(Section) = 0 Or LenB(Key) = 0 Then Exit Sub
   Call m_Settings.IniWrite(Section, Key, Value)
End Sub

Public Function GetCryptedSetting(Section As String, Key As String) As String
    On Local Error Resume Next
    Dim strCrypted As String
    
    strCrypted = m_Settings.IniRead(Section, Key)
    
    If LenB(strCrypted) = 0 Then
        strCrypted = RestoreDefault(Section & "\" & Key)
        Call m_Settings.IniWrite(Section, Key, strCrypted)
    End If
    
    GetCryptedSetting = modCrypt.PasswordDecrypt(Base64Decode(strCrypted))
End Function

Public Sub WriteCryptedSetting(Section As String, Key As String, Value As String)
    Dim strCrypted As String
    
    If LenB(Section) = 0 Or LenB(Key) = 0 Then Exit Sub
    
    strCrypted = Base64Encode(modCrypt.PasswordEncrypt(Value))
    Call m_Settings.IniWrite(Section, Key, strCrypted)
End Sub

Public Sub UnLoadSettings()
   Call WriteSetting("WindowMode", "State", dlgMain.WindowState)
   If dlgMain.WindowState <> 1 Then
      Call WriteSetting("Position", "Left", dlgMain.Left)
      Call WriteSetting("Position", "Top", dlgMain.Top)
      Call WriteSetting("Position", "Width", dlgMain.Width)
      Call WriteSetting("Position", "Height", dlgMain.Height)
   End If
   Set m_Settings = Nothing
End Sub

Public Function RestoreDefault(Key As String) As String
'FIXIT: 'TmpVal' mit einem Datentyp mit frher Bindung deklarieren                         FixIT90210ae-R1672-R1B8ZE
    Dim TmpVal As Variant
    
    ' list to be extended ...
    TmpVal = _
        Switch( _
            Key = "Position\Left", "3000", Key = "Position\Top", "2400", _
            Key = "Position\Width", "2900", Key = "Position\Height", "5200", _
            Key = "ChatWin\Remember", "0", Key = "ChatWin\Width", "7500", _
            Key = "ChatWin\Height", "5000", Key = "ChatWin\Split", "65", _
            Key = "Startup\WithSystem", "0", Key = "Startup\Minimized", "0", _
            Key = "WindowMode\State", "0", Key = "WindowMode\MDI", "0", _
            Key = "WindowMode\AlwaysOnTop", "0", Key = "MessageWindow\Mode", "0", _
            Key = "MessageWindow\SaveHistory", "0", Key = "MessageWindow\CodeWinFixPos", "0", _
            Key = "MessageWindow\CodeWinLeft", "0", Key = "MessageWindow\CodeWinTop", "0", _
            Key = "MessageWindow\CodeWinWidth", "9500", Key = "MessageWindow\CodeWinHeight", "6900", _
            Key = "MessageWindow\MsgStyleNG", "1", Key = "MessageWindow\CreateCodeLog", "1", _
            Key = "AwaySys\Active", "1", Key = "AwaySys\Away", "5", Key = "AwaySys\LongAway", "15", _
            Key = "User\Name", "", Key = "User\Password", "", Key = "User\LogIn", "0", _
            Key = "Sound\AlwaysOn", "1", Key = "Sound\GotMsg", "1,sound\gotmsg.wav", Key = "Sound\GotNewUsr", "1,sound\gotnewUsr.wav", _
            Key = "Sound\GotCode", "1,sound\gotcode.wav", Key = "Sound\GotFile", "1,sound\filetransfer.wav", _
            Key = "Proxy\Enabled", "0", Key = "Proxy\Server", "127.0.0.1", Key = "Proxy\Port", "8080", Key = "Proxy\Override", "", _
            Key = "Proxy\User", "", Key = "Proxy\Password", "", Key = "Connection\Max", "1000", _
            Key = "ClientRelationship\Friends", "", Key = "ClientRelationship\Unwanted", "", _
            Key = "ClientRelationship\BlockUnknown", "0", Key = "ClientRelationship\AllowAuth", "0", _
            Key = "Connection\BandWidthDL", "768", Key = "Connection\BandWidthUL", "128", _
            Key = "Messages\Break", "Oh Mann, ich brauch mal 'ne Pause", Key = "Messages\Away", "Ich bin gleich wieder da", _
            Key = "Messages\LongAway", "Ich bin mal fr lngere Zeit weg", Key = "Messages\Busy", "Jetzt bitte nicht stren, ich bin gerade am debuggen" _
            )
    
    If IsNull(TmpVal) Then _
        RestoreDefault = "" _
    Else _
        RestoreDefault = CStr(TmpVal)
End Function
