VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "IShellInterface"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Version 1.00, 20.01.03
'(c) by Goetz Reinecke 01/2003
'    reinecke@activevb.de

'Diese Klasse wird von allen Clients referenziert. Alle hier
'als Public deklarierten Methoden und Eigenschaften sind dem
'Client daher direkt zugnglich.

Option Explicit

Private Declare Function CLSIDFromProgID Lib "ole32.dll" _
        (ByVal ProgID As Long, rclsid As Guid) As Long

Private Declare Function RegisterActiveObject Lib "oleaut32.dll" _
        (ByVal pUnk As IUnknown, rclsid As Guid, ByVal dwFlags _
        As Long, pdwRegister As Long) As Long
        
        
Private Declare Function RevokeActiveObject Lib "oleaut32.dll" _
        (ByVal dwRegister As Long, ByVal pvReserved As Long) _
        As Long
                
Private Declare Function CoDisconnectObject Lib "ole32.dll" _
        (ByVal pUnk As IUnknown, pvReserved As Long) As Long
        
Private Type Guid
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Private Const ACTIVEOBJECT_STRONG As Long = 0&
Private Const ACTIVEOBJECT_WEAK  As Long = 1&

Public Event eCountOnlineMembers(lCount As Long)
Public Event eGetOnlineMember(lIndex As Long, sNickName As String, lOnlineState As Long, bOpenChat As Boolean)
Public Event eSendFileToUser(sNickName As String, sFileName As String, lRet As Long)

Private hObject As Long
Private lCount As Long

'Initalisierung der Klasse
Private Sub Class_Initialize()
    
Dim GClass As Guid
            
    'Registrieren der Server-Klasse in der Running Object
    'Table (ROT) der Registry. Dies ist notwendig, damit
    'die Clients ein bestehende Instanz des Server-Objekts
    'mit GetObject refrenzieren knnen. Standardmig
    'melden sich in VB-erstellte ActiveX-Komponenten beim
    'Start nicht in der ROT an, daher mu dem hier jetzt
    'nachgeholfen werden.
    
    '1. Guid des Server holen
    If CLSIDFromProgID(StrPtr("ShellInterfaceDLL.IShellInterface"), GClass) = 0 Then
        
        '2. Erhaltene Guid in der ROT anmelden
        Call RegisterActiveObject(Me, GClass, ACTIVEOBJECT_WEAK, hObject)
    End If
End Sub

Public Property Get CountOnlineMembers() As Long
'[ret] long Anzahl Onlinemember
RaiseEvent eCountOnlineMembers(CountOnlineMembers)
End Property

Public Sub GetOnlineMember(lIndex As Long, sNickName As String, lOnlineState As Long, bOpenChat As Boolean)
'[in] lIndex
'[out] sNickName
'[out] lOnlineState
'[out] bOpenChat
RaiseEvent eGetOnlineMember(lIndex, sNickName, lOnlineState, bOpenChat)
End Sub

Public Function SendFileToUser(sNickName As String, sFileName As String) As Long
'[in] sNickName
'[in] sFileName
'[ret] long
RaiseEvent eSendFileToUser(sNickName, sFileName, SendFileToUser)
End Function

'Nicht ffentliche Methode zum beenden des Servers
Public Sub Terminate()

    'Der Eintrag in der ROT mu wieder entfernt werden, sonst
    'bleibt er bestehen und fhrt zu Komplikation bei neu ge-
    'starteten Clients.
    
    'Also Server wieder von der ROT abmelden
    Call RevokeActiveObject(hObject, 0&)
    
    'Trennen aller verbundenen Prozesse die auf den Server ver-
    'weisen, sonst bleibt die Instanz solange im Speicher stehen
    'bis der letzte Client geschlossen wurde.
    Call CoDisconnectObject(Me, 0&)
    
End Sub

Private Sub Class_Terminate()
Call Terminate
End Sub
