VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWinSock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'******************************************************************************
'*      Die WinSockKlasse der Klassenkombination
'*
'*      Diese Klasse muss als WithEvents auf einer Form oder einer anderen Klasse instanziert werden!!!!
'*      Der Klassenname darf nicht verndert werden!!!
'*
'*      Erstellt fr ActiveVB Instant Messenger
'*      (c) 2003 Kai Liebenau
'*      Version: V 0.8.8
'*
'*  History:
'*
'*  Ver 0.8.8   - Bugfixing in CheckBuffer(), Packete wurden manchmal verworfen und BufferOverflow -> PROTECTED
'*  Ver 0.8.7   - Nothing
'*  Ver 0.8.6   - Fehler bei FORWARD_BROADCAST_TO beseitigt, es wurde der falsche Klassenindex benutzt
'*  Ver 0.8.5   - ISocket_ConnectionHasLost mit einer Abfrage auf den Index versehen.
'*  Ver 0.8.4   - Function SendMessage wurde in SocketSendMessage umbenannt
'*              - Function SocketSendMessage um die Auswertung von Ret = -1 erweitert
'*              - Logging in Function CreateNewSocket erweitert
'*              - Handling fr das neue Protokoll Command "PROTOKOLL_UNKNOW_CMD" eingebaut
'*  Ver 0.8.3   - nderung der FT Size Mechanismus(2 neue Schnittstellenfunktionen
'*                und Steuerung komplett in die clsSocket verlegt)
'*              - alle Aufrufe fr CalculateFTSize entfernt(bis auf ganz wenige)
'*  Ver 0.8.2   - Nothing
'*  Ver 0.8.1   - Implementierung der Schnittstelle ISocket
'*              - nderung der SocketLog um die PID
'*              - Einbau von clsWinsock_SendDataToAllConnected
'*              - nderung des Connection Lost Mechanismus um Prfung auf doppelte Connections
'******************************************************************************

Option Explicit

Public Event FileTransferComplete(strRemoteIP As String, strUser As String, strFilename As String, bolAbort As Boolean, bolFaild As Boolean)
Public Event FiletransferProgress(strRemoteIP As String, strUser As String, lngBytes As Long, Sending As Boolean)
Public Event IncomingFile(strRemoteIP As String, strUser As String, strFilename As String, lngFileLength As Long)
Public Event IncomingData(strMessage As String, strRemoteIP As String, strUser As String)
Public Event MaxConnectionRecommed()
Public Event FirewallOrNATRouterDetected()
Public Event ClientDisconnected(strRemoteIP As String, strUsername As String)
Public Event ClientNotConnectable(strRemoteIP As String, strUsername As String)
Public Event DebugMessage(strMessage As String)
Public Event IsListen(bolState As Boolean)
Public Event ConnectionStillAliveIsEstablish(strRemoteIP As String, strUser As String)
Public Event BroadcastForwardingOK(strRemoteIP As String, strUser As String)
Public Event RoutingFaild(strToRemoteIP As String, strToUser As String)
Public Event GatewayConnectionHasLost(strToRemoteIP As String, strToUser As String)
Public Event GatewaySearchByBroadcast(strToRemoteIP As String, strToUser As String)
Public Event GatewayFoundByBroadcast(strToRemoteIP As String, strToUser As String)
Public Event RequestAccept(strSourceUser As String, strSourceIP As String)
Public Event RequestRefused(strUserToConnect As String, strSourceUser As String, strSourceIP As String)

Private Type RoutingClasses
    strIP                           As String
    strUser                         As String
    lngClass                        As Long
    lngConnectionQuality            As ConnectionQuality
    Broadcast                       As Date
End Type

Private Type PacketBuffer
    DataBuffer                      As String
    DataRecived                     As Long
    DataSize                        As Long
    DataBufferCalc                  As Boolean
    SendBuffer                      As Collection
End Type

Private Type SocketConnection
    strDestination                  As String
    strUser                         As String
    bolListen                       As Boolean
    inUse                           As Boolean
    IncomingConnect                 As Boolean
    ProxyConnection                 As Boolean
    ProxyTransmissionInProgress     As Boolean
    ProxyLastSend                   As Date
    LastTraffic                     As Date
    bolFiletransfer                 As Boolean
    bolFiletransferSending          As Boolean
    bolFiletransferReciving         As Boolean
    bSendingInProgress              As Boolean
    cConnection                     As clsSocket
    RecivingInProgress              As Boolean
    CloseRquired                    As Boolean
    Buffer                          As PacketBuffer
End Type

'Dim boolFiletransferNext            As Boolean
Dim bolListen                       As Boolean
Dim cLogin                          As clsLogin
Dim strIncomingFileConnection       As String
Dim udtSocket()                     As SocketConnection
Dim udtRoutingInfo()                As RoutingClasses
Dim lngActiveConnections            As Long

Private c_SocketLogFile             As String
Private c_colSocket                 As New Collection
Private WithEvents cSocketWindow    As clsSocketWindow
Attribute cSocketWindow.VB_VarHelpID = -1

Private c_bolSocketWindowCreated    As Boolean
Private c_lngPID                    As Long
Public WSAStartedUp As Boolean

Implements ISocket 'Schnittstelle von clsSocket

'*****************************************************************************
'* Messageverarbeitung
'*****************************************************************************
Private Sub cSocketWindow_SocketQuery(lngSocket As Long, lngEventID As Long, lngError As Long)
On Local Error Resume Next
Dim cSocket As clsSocket
Set cSocket = c_colSocket("S" & lngSocket)
Debug.Print "SocketMSG for Socket: "; lngSocket
If Not cSocket Is Nothing Then 'Message weiterleiten
    'Debug.Print "MSG forwarden"
    Call cSocket.SocketWndProc(lngEventID, lngError)
End If
lngSocket = 0
Set cSocket = Nothing
End Sub

'******************************************************************************
'* Schnittstelle clsSocket <-> clsWinSock

Private Function ISocket_AcceptRequest(ByVal SocketID As Long) As Long
Dim X As Long
On Local Error GoTo ErrorHandler
X = CreateNewSocket
Debug.Print "Entry clsSocket_AcceptRequest " & X
If X > m_MAX_SOCKET Then
    RaiseEvent MaxConnectionRecommed
    Exit Function
End If
DebugWindow "New Class was created: " & X
Call udtSocket(X).cConnection.AcceptSocket(SocketID)
ISocket_AcceptRequest = 1
Exit Function
ErrorHandler:
MsgBox Err.Description, vbCritical, "Fehler"
End Function
'Public Function clsSocket_AcceptRequest(ByVal SocketID As Long) As Long
'End Function

Private Sub ISocket_AddFileTransferSend()
Call CalculateFTSize(1)
End Sub

Private Sub ISocket_AddToWindow(ByRef cSocketRef As clsSocket, ByVal lngMySocket As Long)
If Not c_bolSocketWindowCreated Then
    m_lngSocketWindowhWnd = cSocketWindow.CreateWindowAndHook
    If m_lngSocketWindowhWnd Then
        c_bolSocketWindowCreated = True
        m_lngSocketMSG = RegisterWindowMessage("Socket.AVBM")
        cSocketWindow.AddMSGFilter = m_lngSocketMSG
    End If
End If
Debug.Print "Socket Added: "; lngMySocket; " Window: "; m_lngSocketWindowhWnd

On Local Error Resume Next
c_colSocket.Remove "S" & lngMySocket
c_colSocket.Add cSocketRef, "S" & lngMySocket
End Sub
'Public Sub clsSocket_AddToWindow(ByRef cSocketRef As clsSocket, ByVal lngMySocket As Long)
'End Sub

Private Sub ISocket_CloseSocket(ByVal lngIndex As Long)
Call DestroySocketClass(lngIndex)
End Sub
'Public Sub clsSocket_CloseSocket(lngIndex As Long)
'End Sub

Private Sub ISocket_ConnectionHasLost(ByVal Index As Long)
Dim strOldSource    As String
Dim strUsername     As String
Dim strFilename     As String
Dim bolFiletransfer As Boolean

If Index < 0 Then Exit Sub

'Winsocke entladen und alle Referenzen zerstren
strOldSource = udtSocket(Index).strDestination
strUsername = udtSocket(Index).strUser
strFilename = udtSocket(Index).cConnection.FileName
bolFiletransfer = udtSocket(Index).bolFiletransfer

Call SocketLog("Connection closed", Index, SOCKETLOG_WARNING)

If udtSocket(Index).CloseRquired = True Then
    Call DestroySocketClass(Index)
Else
    Call DestroySocketClass(Index)
    'Event abfeuern
    If bolFiletransfer Then
        RaiseEvent FileTransferComplete(strOldSource, strUsername, strFilename, False, True)
    Else
        If GetClassItem("", strUsername) > MAX_SOCKET Then
            'Nur auslsen wenn keine Verbindung mehr existiert
            RaiseEvent ClientDisconnected(strOldSource, strUsername)
        Else
            Call SocketLog("Socket was double and closed", Index, SOCKETLOG_INFO_EX)
        End If
    End If
End If
If Not bolFiletransfer Then Call ChangeRoutingByBroadcast(Index)
strOldSource = vbNullString
strUsername = vbNullString
strFilename = vbNullString
End Sub
'Public Function clsSocket_ConnectionHasLost(Index As Long)
'End Function

Private Function ISocket_CreateNewListener() As Boolean
Dim X As Long
'Wir mssen einen neuen Listener erstellen
X = GetFirstFreeClass
'Debuging (No Comment)
DebugWindow "NewListenerClass: " & X
'Socke erstellen
Set udtSocket(X).cConnection = New clsSocket
'Die Referenz nicht vergessen
udtSocket(X).cConnection.clsSocket_SetReferenz Me
udtSocket(X).cConnection.ClassIndex = X

'So jetzt wird es ernst
If udtSocket(X).cConnection.clsSocket_ListenPort = True Then
    'Hurra wir konnte Listen
    udtSocket(X).inUse = True
    'udtSocket(X).cConnection.ClassIndex = X
    bolListen = True
Else
    'Irgenwas ging schief
    udtSocket(X).cConnection.DestroySocket
    Set udtSocket(X).cConnection = Nothing
    udtSocket(X).IncomingConnect = False
    udtSocket(X).RecivingInProgress = False
    bolListen = False
End If
'Sagen wir noch bescheid
RaiseEvent IsListen(udtSocket(X).inUse)
ISocket_CreateNewListener = udtSocket(X).inUse
End Function
'Public Function clsSocket_CreateNewListener() As Boolean
'End Function

Private Sub ISocket_DelFromWindow(ByVal lngMySocket As Long)
On Local Error Resume Next
Err.Clear
Debug.Print "Remove Socket: "; lngMySocket
c_colSocket.Remove ("S" & lngMySocket)
If Err Then Debug.Print "Error while Removing Classreferenz: "; lngMySocket
End Sub
'Public Sub clsSocket_DelFromWindow(ByVal lngMySocket As Long)
'End Sub

Private Sub ISocket_FiletransferProgress(ByVal lngIndex As Long, ByVal lngBytesRecived As Long, ByVal bolSending As Boolean)
'Call SocketLog("FiletransferProgress," & lngBytesRecived, lngIndex, SOCKETLOG_INFO_EX)
RaiseEvent FiletransferProgress(udtSocket(lngIndex).strDestination, udtSocket(lngIndex).strUser, lngBytesRecived, bolSending)
'Call SocketLog("FiletransferProgress back from App", lngIndex, SOCKETLOG_INFO_EX)
End Sub
'Public Sub clsSocket_FiletransferProgress(lngIndex As Long, lngBytesRecived As Long, bolSending As Boolean)
'End Sub

Private Sub ISocket_IncomingData(ByRef strData As String, ByRef strSource As String, ByVal lngIndex As Long)
'Schnittstelle zwischen Winsock und der GUI
Dim cHTTP As clsWinSockHTTP, cHTTPTO As clsWinSockHTTP
Dim lngConnection As Long, BufferStatus As BufferState, lngTempClassID As Long

udtSocket(lngIndex).LastTraffic = Now
On Error GoTo ErrorHandler
'Debug.Print strData
Set cHTTP = New clsWinSockHTTP
If Not udtSocket(lngIndex).RecivingInProgress Then cHTTP.SetHTTPRequest strData
Do
    
    BufferStatus = CheckBuffer(strData, lngIndex, cHTTP)
    If BufferStatus <> DataComplete Then Exit Do
    SocketLog "SocketCommand: " & cHTTP.SocketCommand, lngIndex, SOCKETLOG_INFO_EX
    'Protokollversion berprfen
    Debug.Print cHTTP.ClientProtokollVersion
    If cHTTP.ClientProtokollVersion > PROTOKOLLVERSION Then
        MsgBox "Der einkommende Request hat eine hhere Protokollversion, als" & _
            vbCrLf & "dieser Client ntersttzt. Deshalb kann eine Ordnungsgeme" & _
            vbCrLf & "Verarbeitung nicht Sichergestellt werden!!", vbCritical Or vbSystemModal, "Protokollfehler"
    End If
    If cHTTP.SocketCommandRouting = ROUTING_FORWARDED Then
        'Speichern der UserConnectioninfos
        Call SetRoutingClient(cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser, lngIndex)
    End If
        'hier nochmal alle wichtigen Verbindungsdaten festhalten
    If cHTTP.OverProxy Then
        strSource = cHTTP.SourceIP
        udtSocket(lngIndex).ProxyTransmissionInProgress = True
    End If
    udtSocket(lngIndex).strDestination = strSource
    udtSocket(lngIndex).strUser = cHTTP.User
    udtSocket(lngIndex).ProxyConnection = cHTTP.OverProxy
    'verbindung trennen wenn gewnscht
    If LCase$(cHTTP.Connection) = "close" And udtSocket(lngIndex).IncomingConnect = False Then
        udtSocket(lngIndex).CloseRquired = True
        Call DestroySocketClass(lngIndex)
        Call ChangeRoutingByBroadcast(lngIndex)
    End If
    
    'Spezial Debug
    If InStr(1, cHTTP.User, "HTTP", vbTextCompare) Then SocketLog strData, lngIndex, SOCKETLOG_ERROR_EX
    If InStr(1, cHTTP.User, "POST", vbTextCompare) Then SocketLog strData, lngIndex, SOCKETLOG_ERROR_EX
    
    
    If LenB(cHTTP.SocketCommandRouting) > 0 Then
        Select Case cHTTP.SocketCommandRouting
        '***********************************************************************
        'Routing todo
            Case ROUTING_FORWARD_TO
                lngConnection = GetClassItem(cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser)
                If lngConnection > m_MAX_SOCKET Then
                    Call SocketLog("Routing Forward faild to " & cHTTP.SocketForwardTo & " / " & cHTTP.SocketForwardToUser, lngIndex, SOCKETLOG_INFO_EX)
                    'Not Connection found
                    clsWinSock_SendDatas vbNullString, strSource, cHTTP.User, , cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser, , , ROUTING_FAILD, lngIndex
                Else
                    Call SocketLog("Routing Forward to " & cHTTP.SocketForwardTo & " / " & cHTTP.SocketForwardToUser, lngConnection, SOCKETLOG_INFO_EX)
                    If clsWinSock_SendDatas(cHTTP.RequestMessage, cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser, cHTTP.SocketCommand, strSource, cHTTP.User, , , ROUTING_FORWARDED, lngConnection) = False Then
                        clsWinSock_SendDatas vbNullString, strSource, cHTTP.User, , cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser, , , ROUTING_FAILD, lngIndex
                    End If
                End If
                cHTTP.SocketCommand = "NOP"
            Case ROUTING_FORWARDED
                Call SocketLog("Successful Message routed", lngIndex, SOCKETLOG_INFO_EX)
                cHTTP.User = cHTTP.SocketForwardToUser
                strSource = cHTTP.SocketForwardTo
            Case ROUTING_FAILD
                Call SocketLog("Cant Route To: " & cHTTP.SocketForwardTo & " / " & cHTTP.SocketForwardToUser, lngIndex, SOCKETLOG_INFO_EX)
                RaiseEvent RoutingFaild(cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser)
                cHTTP.SocketCommand = "NOP"
            Case CREATE_ROUTE_TO_LAN
                Call SocketLog("CREATE_ROUTE_TO_LAN " & cHTTP.SocketForwardTo & " / " & cHTTP.SocketForwardToUser, lngIndex, SOCKETLOG_INFO_EX)
                If clsWinSock_SendDatas(cHTTP.RequestMessage, cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser, cHTTP.SocketCommand, strSource, cHTTP.User, , , ROUTING_FORWARDED) = False Then
                    clsWinSock_SendDatas vbNullString, strSource, cHTTP.User, , cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser, , , ROUTING_FAILD, lngIndex
                End If
                cHTTP.SocketCommand = "NOP"
            Case Else
                'Noch nicht implementiert
            End Select
    End If
    Select Case cHTTP.SocketCommand
        Case ROUTING_SEARCH_ROUTE_TO
            SocketLog "ROUTING_SEARCH_ROUTE_TO", lngIndex, SOCKETLOG_INFO_EX
            Set cHTTPTO = New clsWinSockHTTP
            If GetClassItem(cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser) > m_MAX_SOCKET Then
                cHTTPTO.Connection = cHTTP.Connection
                cHTTPTO.SocketCommand = ROUTING_NO_ROUTE
                udtSocket(lngIndex).cConnection.clsSocket_SendData cHTTPTO.GetHTTP_Packet, strSource
            
            Else
                cHTTPTO.Connection = cHTTP.Connection
                cHTTPTO.SocketCommand = ROUTING_GATEWAY_OK
                cHTTPTO.SocketForwardTo = cHTTP.SocketForwardTo
                cHTTPTO.SocketForwardToUser = cHTTP.SocketForwardToUser
                cHTTPTO.SocketConnectionQuality = m_ConnectionQuality
                udtSocket(lngIndex).cConnection.clsSocket_SendData cHTTPTO.GetHTTP_Packet, strSource
            End If
            
            Set cHTTPTO = Nothing
        Case ROUTING_NO_ROUTE
            'Nop
            Debug.Print "No Route for spezific Client"
        Case ROUTING_GATEWAY_OK
            Call SetRoutingClient(cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser, lngIndex, cHTTP.SocketConnectionQuality)
            Debug.Print "Gateway found"
    '****************************************************************************
    '* Filetransfer
        Case FILETRANSFER_WILL_STARTING
            Debug.Print "Filetransfer will starting"
            SocketLog "FILETRANSFER_WILL_STARTING", lngIndex, SOCKETLOG_INFO_EX
            udtSocket(lngIndex).cConnection.FileName = cHTTP.FileName
            udtSocket(lngIndex).cConnection.FileLength = cHTTP.FileLength
            udtSocket(lngIndex).cConnection.UserName = cHTTP.User
            udtSocket(lngIndex).bolFiletransfer = True
            RaiseEvent IncomingFile(strSource, cHTTP.User, cHTTP.FileName, cHTTP.FileLength)
        Case FILETRANSFER_RECONNECT
            'Verbindung aufbauen
            SocketLog "FILETRANSFER_RECONNECT", lngIndex, SOCKETLOG_INFO_EX
            If FiletransferConnectHost(strSource, FILETRANSFER_STILL_CONNECT, cHTTP.User) = False Then
                clsWinSock_SendDatas vbNullString, strSource, cHTTP.User, FILETRANSFER_RECONNECT_FAILD, , , , , , lngIndex
                SocketLog "FILETRANSFER_RECONNECT_FAILD will Send", lngIndex, SOCKETLOG_WARNING_EX
            End If
        Case FILETRANSFER_RECONNECT_FAILD
            'Reconnect ist fehlgeschlagen
            strIncomingFileConnection = "Faild"
            SocketLog "FILETRANSFER_RECONNECT_FAILD", lngIndex, SOCKETLOG_WARNING_EX
        Case FILETRANSFER_STILL_CONNECT
            'Eingehende Stille Filetransferverbindung
            strIncomingFileConnection = strSource
            udtSocket(lngIndex).bolFiletransfer = True
            udtSocket(lngIndex).IncomingConnect = True
            udtSocket(lngIndex).strDestination = strSource
            udtSocket(lngIndex).strUser = cHTTP.User
            SocketLog "FILETRANSFER_STILL_CONNECT", lngIndex, SOCKETLOG_INFO_EX
        Case FILETRANSFER_START
            Debug.Print "Transfer Start"
            udtSocket(lngIndex).cConnection.FileRecive = True
            udtSocket(lngIndex).bolFiletransferReciving = True
            'Call CalculateFTSize(1)
        Case FILETRANSFER_OK
            Debug.Print "Filetransfer starting"
            SocketLog "FILETRANSFER_OK", lngIndex, SOCKETLOG_INFO_EX
            Set cHTTPTO = New clsWinSockHTTP
            With cHTTPTO
                .Answer = udtSocket(lngIndex).IncomingConnect
                .Content_Type = "gzip/binary"
                .FileLength = udtSocket(lngIndex).cConnection.FileLength
                '.Filename = udtSocket(lngIndex).cConnection.Filename
                .Content_Range = 0
                .IP = strSource
                .SocketCommand = FILETRANSFER_START
                .Content_Length = .Content_Length + .FileLength
                udtSocket(lngIndex).cConnection.clsSocket_SendData cHTTPTO.GetHTTP_Packet, strSource
                DoEvents
            End With
            udtSocket(lngIndex).cConnection.UserName = cHTTP.User
            udtSocket(lngIndex).CloseRquired = True
            If udtSocket(lngIndex).cConnection.FileSend Then
                udtSocket(lngIndex).bolFiletransferSending = True
                'Call CalculateFTSize(1)
            Else
                RaiseEvent FileTransferComplete(strSource, cHTTP.User, udtSocket(lngIndex).cConnection.FileName, False, True)
                Call DestroySocketClass(lngIndex)
            End If
        Case FILETRANSFER_ABORT
            'Dateitransfer abgebrochen
            RaiseEvent FileTransferComplete(strSource, cHTTP.User, udtSocket(lngIndex).cConnection.FileName, True, False)
            If udtSocket(lngIndex).bolFiletransfer Then
                udtSocket(lngIndex).cConnection.FileTransferAbort = True
                'If udtSocket(lngIndex).bolFiletransferSending Then Call CalculateFTSize(-1)
                udtSocket(lngIndex).bolFiletransferReciving = False
                udtSocket(lngIndex).bolFiletransferSending = False
                Call DestroySocketClass(lngIndex)
            Else
                lngConnection = GetClassItem(strSource, cHTTP.User, True)
                If lngConnection <= m_MAX_SOCKET Then
                    udtSocket(lngConnection).cConnection.FileTransferAbort = True
                    'If udtSocket(lngIndex).bolFiletransferSending Then Call CalculateFTSize(-1)
                    udtSocket(lngConnection).bolFiletransferReciving = False
                    udtSocket(lngConnection).bolFiletransferSending = False
                    Call DestroySocketClass(lngConnection)
                End If
            End If
            SocketLog "FILETRANSFER_ABORT", lngIndex, SOCKETLOG_INFO_EX
        Case CONNECTION_CLOSED
            Call DestroySocketClass(lngIndex)
            SocketLog "CONNECTION_CLOSED", lngIndex, SOCKETLOG_INFO_EX
'****************************************************************************
'* Broadcast Nachrichten
        Case FORWARD_BROADCAST_TO_NEW
            SocketLog "FORWARD_BROADCAST_TO_NEW", lngIndex, SOCKETLOG_INFO_EX
            Set cHTTPTO = New clsWinSockHTTP
            If clsWinSock_SendDatas(vbNullString, _
                                    cHTTP.SocketForwardTo, _
                                    cHTTP.SocketForwardToUser, _
                                    BROADCAST_CONNECT_TO, _
                                    strSource, cHTTP.User, _
                                    True) = True Then
                cHTTPTO.SocketCommand = FORWARD_BROADCAST_OK
                cHTTPTO.SocketForwardTo = cHTTP.SocketForwardTo
                cHTTPTO.SocketForwardToUser = cHTTP.SocketForwardToUser
            Else
                cHTTPTO.SocketCommand = FORWARD_BROADCAST_FAILD
            End If
            SocketLog cHTTPTO.SocketCommand, lngIndex, SOCKETLOG_INFO_EX
            cHTTPTO.Answer = udtSocket(lngIndex).IncomingConnect
            SocketSendMessage cHTTPTO.GetHTTP_Packet, lngIndex, strSource
            Set cHTTPTO = Nothing
        Case FORWARD_BROADCAST_TO
            SocketLog "FORWARD_BROADCAST_TO", lngIndex, SOCKETLOG_INFO_EX
            lngConnection = GetClassItem(cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser)
            Debug.Print "SocketCommand: "; cHTTP.SocketCommand
            SocketLog "Class", lngConnection, SOCKETLOG_INFO_EX
            SocketLog "to: " & cHTTP.SocketForwardTo, lngConnection, SOCKETLOG_INFO_EX
            SocketLog "to User: " & cHTTP.SocketForwardToUser, lngConnection, SOCKETLOG_INFO_EX
            If lngConnection < m_MAX_SOCKET + 1 Then
                Set cHTTPTO = New clsWinSockHTTP
                With cHTTPTO
                    .SocketCommand = BROADCAST_CONNECT_TO
                    .SocketForwardToUser = cHTTP.User
                    .SocketForwardTo = strSource
                    SocketSendMessage .GetHTTP_Packet, lngConnection, cHTTP.SocketForwardTo    ', True
                End With
                Set cHTTPTO = Nothing
                DoEvents
            End If
            Set cHTTPTO = New clsWinSockHTTP
            cHTTPTO.Answer = udtSocket(lngIndex).IncomingConnect
            With cHTTPTO
                .Connection = cHTTP.Connection
                If lngConnection < m_MAX_SOCKET + 1 Then
                    SocketLog "Successfully Forwarding", lngConnection, SOCKETLOG_INFO_EX
                    .SocketCommand = FORWARD_BROADCAST_OK
                    .SocketForwardTo = cHTTP.SocketForwardTo
                    .SocketForwardToUser = cHTTP.SocketForwardToUser
                Else
                    SocketLog "Faild Forwarding", lngIndex, SOCKETLOG_INFO_EX
                    .SocketCommand = FORWARD_BROADCAST_FAILD
                End If
                SocketSendMessage cHTTPTO.GetHTTP_Packet, lngIndex, strSource
            End With
            Set cHTTPTO = Nothing
        Case FORWARD_BROADCAST_OK
            SocketLog "Forward OK", lngIndex, SOCKETLOG_INFO_EX
            RaiseEvent BroadcastForwardingOK(strSource, cHTTP.User)
        Case FORWARD_BROADCAST_FAILD
            SocketLog "Forward faild", lngIndex, SOCKETLOG_WARNING
        Case BROADCAST_CONNECT_TO
            SocketLog "BROADCAST_CONNECT_TO " & cHTTP.SocketForwardTo & " / " & cHTTP.SocketForwardToUser, lngIndex, SOCKETLOG_INFO_EX
            m_NAT_Firewall_detected = True
            clsWinSock_SendDatas vbNullString, cHTTP.SocketForwardTo, cHTTP.SocketForwardToUser, CONNECTION_STILL_ALIVE, , , , True
            RaiseEvent FirewallOrNATRouterDetected

'***************************************************************************
'* allgemeine Nachrichten
        Case CONNECTION_DOUBLE_CLOSE
            Call DestroySocketClass(lngIndex)
        Case CONNECTION_STILL_ACCEPT
            RaiseEvent RequestAccept(cHTTP.User, strSource)
        Case CONNECTION_STILL_REFUSE
            RaiseEvent RequestRefused(cHTTP.RequestMessage, cHTTP.User, strSource)
        Case CONNECTION_STILL_MESSAGE
            'nur Connectionaufbau fr neue Chatverbindung
            Call SocketLog("CONNECTION_STILL_MESSAGE", lngIndex, SOCKETLOG_INFO)
            If LCase$(LocalUser.cpUsername) = LCase$(cHTTP.RequestMessage) Then
                Call SocketLog("CONNECTION_STILL_ACCEPT", lngIndex, SOCKETLOG_INFO_EX)
                clsWinSock_SendDatas cHTTP.RequestMessage, strSource, cHTTP.User, CONNECTION_STILL_ACCEPT ', , , , , , lngIndex
            Else
                Call SocketLog("CONNECTION_STILL_REFUSE", lngIndex, SOCKETLOG_INFO_EX)
                clsWinSock_SendDatas cHTTP.RequestMessage, strSource, cHTTP.User, CONNECTION_STILL_REFUSE ', , , , , , lngIndex
            End If
            DoEvents
            'Prfung auf dopellte Connection
            lngTempClassID = GetClassItemIP(strSource, lngIndex)
            If lngTempClassID <= m_MAX_SOCKET Then
                If udtSocket(lngTempClassID).strUser = cHTTP.User Then _
                    clsWinSock_SendDatas cHTTP.RequestMessage, strSource, cHTTP.User, CONNECTION_DOUBLE_CLOSE, , , , , , lngTempClassID
            End If
        Case CONNECTION_STILL_ALIVE
            'sage bescheid das eine Eingehende stille Verbindung kam
            Set cHTTPTO = New clsWinSockHTTP
            cHTTPTO.SocketCommand = "NOP"
            SocketSendMessage cHTTPTO.GetHTTP_Packet, lngIndex, strSource
            Set cHTTPTO = Nothing
            RaiseEvent ConnectionStillAliveIsEstablish(strSource, cHTTP.User)
            SocketLog "CONNECTION_STILL_ALIVE", lngIndex, SOCKETLOG_INFO_EX
            Debug.Print "Still Alive Incoming"
        Case SOCKET_MAX_CONNECTION
            'Connected Host hat keine ConnectionKlasse mehr frei
            Call DestroySocketClass(lngIndex)
            Call SocketLog("Max Connection from RemoteHost", lngIndex, SOCKETLOG_INFO_EX)
            RaiseEvent ClientNotConnectable(strSource, cHTTP.User)
        Case AVBM_MESSAGE
            DebugWindow "Incoming Message"
            udtSocket(lngIndex).ProxyTransmissionInProgress = True
            If cHTTP.OverProxy = True Then
                RaiseEvent IncomingData(cHTTP.RequestMessage, cHTTP.SourceIP, cHTTP.User)
            Else
                RaiseEvent IncomingData(cHTTP.RequestMessage, strSource, cHTTP.User)
            End If
        Case PROXY_GET_MESSAGE
            'Call SendWaitingMessage(lngIndex)
            udtSocket(lngIndex).ProxyTransmissionInProgress = True
        Case PROXY_NO_MORE_MESSAGE
            'nop
            udtSocket(lngIndex).ProxyLastSend = Now
        Case "NOP"
            'Nothing to do
        Case PROTOKOLL_UNKNOW_CMD
            'Return Unknow Protokoll Command
            SocketLog "Other Client sends Unknow Protocolcommand detected, " & cHTTP.ClientProtokollVersion & vbTab & PROTOKOLLVERSION, lngIndex, SOCKETLOG_ERROR_EX
        Case Else
            SocketLog "HTTP ErrorDescription: " & cHTTP.ErrorDescription, lngIndex, SOCKETLOG_ERROR_EX
            SocketLog "HTTP ErrorCode: " & cHTTP.ErrorCode, lngIndex, SOCKETLOG_ERROR_EX
            SocketLog "Unknow Protocolcommand recived, " & cHTTP.ClientProtokollVersion & vbTab & PROTOKOLLVERSION, lngIndex, SOCKETLOG_ERROR_EX
            If Len(cHTTP.User) Then _
                clsWinSock_SendDatas "", strSource, cHTTP.User, PROTOKOLL_UNKNOW_CMD
            
    End Select
    If udtSocket(lngIndex).ProxyConnection = True Then Call SendWaitingMessage(lngIndex)
    If m_ProxyEnabled = True And cHTTP.SocketCommand <> PROXY_NO_MORE_MESSAGE Then
        'Timer zurcksetzen
        udtSocket(lngIndex).ProxyLastSend = Now - 5
    End If
    cHTTP.GetNextHTTPRequest
Loop While cHTTP.MessageWaiting = True
udtSocket(lngIndex).ProxyTransmissionInProgress = False
Set cHTTP = Nothing
Exit Sub

ErrorHandler:
SocketLog "Fehler bei clsIncomingMessage: " & Err.Description, lngIndex, SOCKETLOG_ERROR
SocketLog "SocketCommand: " & cHTTP.SocketCommand, lngIndex, SOCKETLOG_INFO_EX
Set cHTTP = Nothing
End Sub
'Public Function clsSocket_IncomingData(ByRef strData As String, strSource As String, lngIndex As Long) As String
'End Function

Private Sub ISocket_RemoveFileTransferSend()
Call CalculateFTSize(-1)
End Sub

Private Sub ISocket_SetDestination(ByVal Index As Long, ByRef Destination As String)
'Wenn uns jemand anspricht, dann mssen wir uns seine Addresse merken
udtSocket(Index).strDestination = Destination
udtSocket(Index).IncomingConnect = True
End Sub
'Public Sub clsSocket_SetDestination(Index As Long, Destination As String)
'End Sub

Private Sub ISocket_SocketLog(ByRef strDebugMessage As String, ByVal SocketClass As Long, ByVal lngLogLevel As SocketLogModeEnum)
Call SocketLog(strDebugMessage, SocketClass, lngLogLevel)
End Sub

'*****************************************************************************
'*
'*****************************************************************************
Private Sub DebugWindow(strMessage As String)
'Debuging ???
RaiseEvent DebugMessage(strMessage)
End Sub



'Private Sub DeleteRoutingClas(ByVal lngIndex As Long)
'On Local Error Resume Next
'Dim X As Long
'For X = 0 To UBound(udtRoutingInfo)
'    If udtRoutingInfo(X).lngClass = lngIndex Then udtRoutingInfo(X).lngClass = m_MAX_SOCKET + 1
'Next
'End Sub

Private Sub ChangeRoutingByBroadcast(ByVal lngIndex As Long)
On Local Error GoTo ErrorHandler
Dim X As Long, Y As Long

For X = 0 To UBound(udtRoutingInfo)
    If udtRoutingInfo(X).lngClass = lngIndex Then
        Debug.Print "Gateway has lost"; lngIndex; vbTab; X
        Call SocketLog("Gateway has lost, Searching by Broadcast: " & lngIndex, udtRoutingInfo(lngIndex).lngClass, SOCKETLOG_WARNING_EX)
        RaiseEvent GatewaySearchByBroadcast(udtRoutingInfo(X).strIP, udtRoutingInfo(X).strUser)
        udtRoutingInfo(X).lngClass = m_MAX_SOCKET + 1
        udtRoutingInfo(X).lngConnectionQuality = 0
        For Y = 0 To m_MAX_SOCKET
            If udtSocket(Y).inUse = True And _
               LenB(udtSocket(Y).strDestination) > 0 And _
               LenB(udtSocket(Y).strUser) > 0 Then
               clsWinSock_SendDatas "", udtSocket(Y).strDestination, udtSocket(Y).strUser, ROUTING_SEARCH_ROUTE_TO, _
               udtRoutingInfo(X).strIP, udtRoutingInfo(X).strUser, , True
               Debug.Print "Sending Broadcast"
            End If
        Next
        udtRoutingInfo(X).Broadcast = Now
    End If
Next
Exit Sub
ErrorHandler:
'Debug.Print "Error in ChangeRoutingByBroadcast"
'Debug.Print "Error: "; Err.Description
End Sub
Private Sub SetRoutingClient(strIP As String, strUser As String, lngIndex As Long, Optional ConnQuality As ConnectionQuality)
Dim X As Long, bolFound As Boolean
On Local Error GoTo ErrorHandler
For X = 0 To UBound(udtRoutingInfo)
    If udtRoutingInfo(X).strIP = strIP And LCase$(udtRoutingInfo(X).strUser) = LCase$(strUser) Then
       If udtRoutingInfo(X).lngConnectionQuality >= ConnQuality Then _
        udtRoutingInfo(X).lngClass = lngIndex
        bolFound = True
    End If
Next
If Not bolFound Then
    ReDim Preserve udtRoutingInfo(UBound(udtRoutingInfo) + 1)
    udtRoutingInfo(UBound(udtRoutingInfo)).lngClass = lngIndex
    udtRoutingInfo(UBound(udtRoutingInfo)).strUser = strUser
    udtRoutingInfo(UBound(udtRoutingInfo)).strIP = strIP
End If
Exit Sub
ErrorHandler:
ReDim udtRoutingInfo(0)
udtRoutingInfo(0).lngClass = lngIndex
udtRoutingInfo(0).strUser = strUser
udtRoutingInfo(0).strIP = strIP
Resume
End Sub

'Private Function GetRoutingClas(strIP As String, strUser As String) As Long
Private Function GetRoutingClas(strUser As String) As Long
GetRoutingClas = m_MAX_SOCKET + 1
Dim X As Long
On Local Error GoTo ErrorHandler
For X = 0 To UBound(udtRoutingInfo)
    'MsgBox "IP: " & udtRoutingInfo(X).strIP & vbCrLf & _
           "User: " & udtRoutingInfo(X).strUser
    'If udtRoutingInfo(X).strIP = strIP And _
       LCase$(udtRoutingInfo(X).strUser) = LCase$(strUser) Then _
       GetRoutingClas = udtRoutingInfo(X).lngClass
    If LCase$(udtRoutingInfo(X).strUser) = LCase$(strUser) Then _
       GetRoutingClas = udtRoutingInfo(X).lngClass
Next

Exit Function
ErrorHandler:
'ReDim udtRoutingInfo(0)
End Function
Private Function GetClassItem(Destination As String, strUser As String, Optional isFiletransfer As Boolean = False) As Long
Dim X As Long
If Len(Destination) = 0 And Len(strUser) = 0 Then GetClassItem = m_MAX_SOCKET + 1: Exit Function
'sucht eine bestimmte Socke
For X = 0 To m_MAX_SOCKET
    'If udtSocket(X).strDestination = Destination And _
        udtSocket(X).bolFiletransfer = isFiletransfer And _
        LCase$(udtSocket(X).strUser) = LCase$(strUser) Then Exit For
    If udtSocket(X).bolFiletransfer = isFiletransfer And _
        LCase$(udtSocket(X).strUser) = LCase$(strUser) Then
        If udtSocket(X).cConnection Is Nothing Then
            Call DestroySocketClass(X)
        Else
            Exit For
        End If
    End If
Next
GetClassItem = X
End Function
Private Function GetClassItemIP(Destination As String, lngExcludeID As Long, Optional isFiletransfer As Boolean = False) As Long
Dim X As Long
If Len(Destination) = 0 Then GetClassItemIP = m_MAX_SOCKET + 1: Exit Function
'sucht eine bestimmte Socke
For X = 0 To m_MAX_SOCKET
    If lngExcludeID <> X Then
        If udtSocket(X).bolFiletransfer = isFiletransfer And _
            LCase$(udtSocket(X).strDestination) = LCase$(Destination) Then
            If udtSocket(X).cConnection Is Nothing Then
                Call DestroySocketClass(X)
            Else
                Exit For
            End If
        End If
    End If
Next
GetClassItemIP = X
End Function

Private Function GetFirstFreeClass() As Long
Dim X As Long
'Sucht die erste freie Socke raus
For X = 0 To m_MAX_SOCKET
    If udtSocket(X).inUse = False Then Exit For
Next
GetFirstFreeClass = X
End Function

Public Function clsWinSock_CloseConnection(strRemoteIP As String, strUser As String) As Boolean
Dim X As Long, cHTTP As clsWinSockHTTP
'Wir wollen eine Verbindung beenden
'Suchen wir sie erstmal
X = GetClassItem(strRemoteIP, strUser)
'Gabs denn berhaupt eine?
If X > m_MAX_SOCKET Then Exit Function
Set cHTTP = New clsWinSockHTTP
With cHTTP
    .Connection = "close"
    .SocketCommand = CONNECTION_CLOSED
    
    'Ja es gab sie, also wech mit der Socke
    Call udtSocket(X).cConnection.clsSocket_SendData(cHTTP.GetHTTP_Packet, strRemoteIP)
    Sleep 100
    DoEvents
    Sleep 100
    DoEvents
End With
Set cHTTP = Nothing
'udtSocket(X).cConnection.clsSocket_EndWinSock
DoEvents
Call DestroySocketClass(X)
Call ChangeRoutingByBroadcast(X)
'Wir konnten was beenden
clsWinSock_CloseConnection = True
End Function



Private Function CheckBuffer(ByRef strData As String, lngIndex As Long, ByRef cHTTP As clsWinSockHTTP) As BufferState
'Wenn der Buffer im vorherigen Packet nicht berechnet werden konnte, so wird dies jetzt wiederholt
If udtSocket(lngIndex).RecivingInProgress = True And udtSocket(lngIndex).Buffer.DataBufferCalc = False Then
    strData = udtSocket(lngIndex).Buffer.DataBuffer & strData
    udtSocket(lngIndex).RecivingInProgress = False
    Call cHTTP.SetHTTPRequest(strData)
End If

If udtSocket(lngIndex).RecivingInProgress = False Then
    'Es wird nicht auf Daten gewartet
    If cHTTP.SocketCommand <> FILETRANSFER_START Then
        If cHTTP.IsBufferCalculate = False Then
            'Buffer ist nicht berechenbar !!!
            udtSocket(lngIndex).Buffer.DataBuffer = strData
            udtSocket(lngIndex).Buffer.DataBufferCalc = False
            udtSocket(lngIndex).RecivingInProgress = True
            CheckBuffer = DataBuffered
            Exit Function
        End If
        If cHTTP.Content_Length + cHTTP.HeaderLength > cHTTP.PacketSize Then
            Debug.Print "First Packet"; cHTTP.Content_Length + cHTTP.HeaderLength; Len(strData)
            'Es folgen noch Packete
            udtSocket(lngIndex).RecivingInProgress = True
            udtSocket(lngIndex).Buffer.DataSize = cHTTP.Content_Length + cHTTP.HeaderLength
            udtSocket(lngIndex).Buffer.DataBuffer = String$(udtSocket(lngIndex).Buffer.DataSize, 0)
            MidB$(udtSocket(lngIndex).Buffer.DataBuffer, udtSocket(lngIndex).Buffer.DataRecived * 2 + 1, cHTTP.PacketSize * 2) = cHTTP.GetPacketForBuffer
            strData = MidB$(strData, cHTTP.PacketSize * 2 + 1)
            udtSocket(lngIndex).Buffer.DataRecived = cHTTP.PacketSize
            'Set cHTTP = Nothing
            udtSocket(lngIndex).Buffer.DataBufferCalc = True
            CheckBuffer = DataBuffered
            Exit Function
        Else
            CheckBuffer = DataComplete
            Debug.Print "Full Packet"
        End If
    Else
        CheckBuffer = DataComplete
    End If
Else
    'nchstes Packet
    If udtSocket(lngIndex).Buffer.DataRecived + Len(strData) > udtSocket(lngIndex).Buffer.DataSize Then
        'Buffer Overflow
        Call SocketLog("Buffer overflow PROTECTED", lngIndex, SOCKETLOG_WARNING_EX)
        Debug.Print "Buffer Overflow PROECTED"; udtSocket(lngIndex).Buffer.DataRecived + Len(strData)
        
        cHTTP.SetHTTPRequest LeftB$(udtSocket(lngIndex).Buffer.DataBuffer, udtSocket(lngIndex).Buffer.DataRecived * 2) & strData
        
        udtSocket(lngIndex).Buffer.DataBufferCalc = False
        udtSocket(lngIndex).Buffer.DataRecived = 0
        udtSocket(lngIndex).Buffer.DataSize = 0
        udtSocket(lngIndex).Buffer.DataBuffer = vbNullString
        udtSocket(lngIndex).RecivingInProgress = False
        'Set cHTTP = Nothing
        'CheckBuffer = DataBufferOverflow '
        CheckBuffer = DataComplete
        Exit Function
        
    End If
    MidB$(udtSocket(lngIndex).Buffer.DataBuffer, udtSocket(lngIndex).Buffer.DataRecived * 2 + 1, LenB(strData)) = strData
    udtSocket(lngIndex).Buffer.DataRecived = udtSocket(lngIndex).Buffer.DataRecived + Len(strData)
    Debug.Print "Packet Next"; udtSocket(lngIndex).Buffer.DataRecived
    If udtSocket(lngIndex).Buffer.DataRecived < udtSocket(lngIndex).Buffer.DataSize Then
        'Es fehlen noch Daten
        Debug.Print "Buffer nicht voll"; udtSocket(lngIndex).Buffer.DataRecived
        'Set cHTTP = Nothing
        CheckBuffer = DataBuffered
        Exit Function
    Else
        'Alle Daten da
        Debug.Print "Packet recived"
        
        cHTTP.SetHTTPRequest udtSocket(lngIndex).Buffer.DataBuffer
        udtSocket(lngIndex).Buffer.DataBufferCalc = False
        udtSocket(lngIndex).RecivingInProgress = False
        udtSocket(lngIndex).Buffer.DataBuffer = vbNullString
        udtSocket(lngIndex).Buffer.DataRecived = 0
        udtSocket(lngIndex).Buffer.DataSize = 0
        CheckBuffer = DataComplete
    End If
End If
End Function

Private Function CreateNewSocket() As Long
Dim X As Long

X = GetFirstFreeClass
If X <= m_MAX_SOCKET Then
    'Debuging (No Comment)
    DebugWindow "NewConnectionClas: " & X
    SocketLog "Create NewSocketClass", X, SOCKETLOG_INFO_EX
    'Diese Socke ist jetzt belegt
    udtSocket(X).inUse = True
    udtSocket(X).LastTraffic = Now
    'Das initialisieren nicht vergessen
    Set udtSocket(X).cConnection = New clsSocket
    'Und die Referenz auch nicht!!!
    udtSocket(X).cConnection.clsSocket_SetReferenz Me
    udtSocket(X).cConnection.ClassIndex = X
    Set udtSocket(X).Buffer.SendBuffer = New Collection
    udtSocket(X).ProxyLastSend = Now
Else
    RaiseEvent MaxConnectionRecommed
    SocketLog "Maximale Anzahl an Sockets erreicht!", -1, SOCKETLOG_WARNING_EX
End If
CreateNewSocket = X
End Function
Public Function clsWinSock_SendDataToAllConnected(strMessage As String, _
                      Optional ByVal strSocketCommand As String = AVBM_MESSAGE, _
                      Optional ByVal bolBroadcast As Boolean = False) As Boolean
Dim X As Long, cHTTP As clsWinSockHTTP, Ret As Long
'Funktion sendet eine Message an alle Clients die Connected sind

On Local Error Resume Next
Debug.Print "SocketSendMessageToAllConnected"
Set cHTTP = New clsWinSockHTTP

cHTTP.SocketCommand = strSocketCommand
cHTTP.RequestMessage = strMessage
cHTTP.SocketCommandRouting = vbNullString

For X = 0 To MAX_SOCKET
    If udtSocket(X).inUse = True And _
       udtSocket(X).bolListen = False And _
       udtSocket(X).bolFiletransfer = False Then
        
        cHTTP.Answer = udtSocket(X).IncomingConnect
        SocketSendMessage cHTTP.GetHTTP_Packet, X, udtSocket(X).strDestination, bolBroadcast
    End If
Next

'geroutete Verbindungen abarbeiten
Err.Clear
Ret = UBound(udtRoutingInfo)
If Err Then
    clsWinSock_SendDataToAllConnected = True
    Exit Function
End If

cHTTP.SocketCommand = ROUTING_FORWARD_TO
cHTTP.SocketCommandRouting = strSocketCommand

For X = 0 To Ret
    cHTTP.SocketForwardTo = udtRoutingInfo(X).strIP
    cHTTP.SocketForwardToUser = udtRoutingInfo(X).strUser
    cHTTP.Answer = udtSocket(udtRoutingInfo(X).lngClass).IncomingConnect
    SocketSendMessage cHTTP.GetHTTP_Packet, udtRoutingInfo(X).lngClass, udtSocket(udtRoutingInfo(X).lngClass).strDestination, bolBroadcast
Next
clsWinSock_SendDataToAllConnected = True
Set cHTTP = Nothing
End Function
Public Function clsWinSock_SendDatas(strMessage As String, _
                               ByVal strRemoteIP As String, _
                               ByVal strUser As String, _
                      Optional ByVal strSocketCommand As String = AVBM_MESSAGE, _
                      Optional ByVal strForwardTo As String = vbNullString, _
                      Optional ByVal strForwardToUser As String = vbNullString, _
                      Optional ByVal bolCreateNewConnection As Boolean = True, _
                      Optional ByVal bolBroadcast As Boolean = False, _
                      Optional ByVal strSocketCommandRouting As String = vbNullString, _
                      Optional ByVal lngClassID As Long = -1) As Boolean
                      
Dim X As Long, cHTTP As clsWinSockHTTP, strTemp As String ', Ret As Long
Dim bolRouting As Boolean, lSendRet As Long ', lngSendTime As Long, lngTempClass As Long
'Wir wollen Daten senden
'Dazu erstmal schauen ob schon eine Verbindung existiert
On Local Error Resume Next
If Len(strRemoteIP) = 0 Or Len(strUser) = 0 Then Exit Function
'Prfung auf eigene RemoteIP
'Exit Function
Debug.Print "User: "; strUser, "IP: "; strRemoteIP
Debug.Print "Message: "; strMessage, "SC: "; strSocketCommand
Debug.Print "RSC: "; strSocketCommandRouting
Debug.Print "FSC_to: "; strForwardTo, "FSC_User: "; strForwardToUser
Nochmal:

If lngClassID = -1 Then
    If strRemoteIP = LocalUser.cpRemoteIP Then Exit Function
    If strRemoteIP = LocalUser.cpLAN_IP Then Exit Function
    X = GetClassItem(strRemoteIP, strUser)
Else
    X = lngClassID
End If
'wenn es eine eingehende und Proxyconnection ist, dann ab in den Stack und warten
'StackMessages mssen vom Proxyclient abgeholt werden, sie knnen nicht einfach gesendet werden

'todo
If X > m_MAX_SOCKET Then
    'Nicht, schade. Na dann machen wir eben eine auf
    'X = GetRoutingClas(strRemoteIP, strUser)
    X = GetRoutingClas(strUser)
    If X > m_MAX_SOCKET Then
        'Bjrn: Halt halt, nicht so schnell. Bitte nur, wenn das auch erlaubt wurde'
        If Not bolCreateNewConnection Then Exit Function
        X = CreateNewSocket()
        If Not (X > m_MAX_SOCKET) Then udtSocket(X).ProxyConnection = m_ProxyEnabled
    Else
        strSocketCommandRouting = ROUTING_FORWARD_TO
        strForwardTo = strRemoteIP
        strForwardToUser = strUser
        bolRouting = True
    End If
    If X > m_MAX_SOCKET Then Exit Function
Else
    Err.Clear
    If udtSocket(X).cConnection.Connected = False Then
        lngClassID = -1
        DestroySocketClass X
        GoTo Nochmal
    End If
    If Err Then
        lngClassID = -1
        DestroySocketClass X
        GoTo Nochmal
    End If
    If strSocketCommandRouting = ROUTING_FORWARD_TO Then
        SetRoutingClient strForwardTo, strForwardToUser, X
    End If
End If

If Not bolRouting Then
    udtSocket(X).strDestination = strRemoteIP
    udtSocket(X).strUser = strUser
End If

Set cHTTP = New clsWinSockHTTP
With cHTTP
    .OverProxy = udtSocket(X).ProxyConnection
    .Answer = udtSocket(X).IncomingConnect
    .SocketCommandRouting = strSocketCommandRouting
    .SocketCommand = strSocketCommand               'BROADCAST_CONNECT_TO '
    .SocketForwardTo = strForwardTo                 '"62.143.17.219" '
    .SocketForwardToUser = strForwardToUser         '"Jrg"
    .RequestMessage = strMessage
    .IP = strRemoteIP
    If strSocketCommand = CONNECTION_DOUBLE_CLOSE Then
        .Connection = "close"
        udtSocket(X).CloseRquired = True
    End If
    If m_SendBuffer = 0 Then
        If udtSocket(X).cConnection.clsSocket_Connect(strRemoteIP) = False Then Exit Function
    End If
    'So, dann mal wech mit den Daten
    strTemp = cHTTP.GetHTTP_Packet
    Call SocketLog("Will sending Socketcommand: " & cHTTP.SocketCommand, X, SOCKETLOG_INFO_EX)
    
    Set cHTTP = Nothing
    
    If udtSocket(X).bSendingInProgress = True Then
        udtSocket(X).Buffer.SendBuffer.Add strTemp
        clsWinSock_SendDatas = True
        Exit Function
    End If

    udtSocket(X).bSendingInProgress = True
    Do
        lSendRet = SocketSendMessage(strTemp, X, strRemoteIP, bolBroadcast)
        If lSendRet = 1 Then
            'Es hat funktioniert, dann noch die IP speichern
            If Not bolRouting Then
                udtSocket(X).strDestination = strRemoteIP
                udtSocket(X).strUser = strUser
            End If
            clsWinSock_SendDatas = True
            Debug.Print "Send OK"
            'If m_FTSendBuffer = 0 Then Call CalculateFTSize(0)
        Else
            'Nein, dann schmei die Socke weg. Hat eh nix gentzt
            SocketLog "Sending faild, " & lSendRet, X, SOCKETLOG_INFO_EX
            Call DestroySocketClass(X)
            Exit Do
        End If
        'Sendbuffer lschen
        strTemp = vbNullString
        
        udtSocket(X).ProxyTransmissionInProgress = False
        'bei Proxy immer nur 1 MSG
        If udtSocket(X).ProxyConnection Then Exit Do
        '
        If udtSocket(X).Buffer.SendBuffer.Count > 0 Then
            strTemp = udtSocket(X).Buffer.SendBuffer(1)
            udtSocket(X).Buffer.SendBuffer.Remove (1)
        End If
    Loop While Len(strTemp)
    udtSocket(X).bSendingInProgress = False
    
'in Vorbereitung, muss noch getestet werden!!!!
'If bolCreateNewConnection = False Then Call DestroySocketClass(X)
End With

Set cHTTP = Nothing
End Function

Private Function SocketSendMessage(strMessage As String, ByVal lngClassID As Long, ByVal strRemoteIP As String, Optional ByVal bolBroadcast As Boolean = False) As Long
On Error Resume Next
Dim Ret As Long
Dim lngSendTime As Long
Dim tTime As Date

'Proxysupportabfrage
If udtSocket(lngClassID).IncomingConnect = True And udtSocket(lngClassID).ProxyConnection = True And _
   udtSocket(lngClassID).ProxyTransmissionInProgress = False Then
    udtSocket(lngClassID).Buffer.SendBuffer.Add strMessage
    SocketSendMessage = 1
    Exit Function
End If

udtSocket(lngClassID).ProxyTransmissionInProgress = False

SocketSendMessage = 1
lngSendTime = CLng(TIMEOUT_SENDDATA / m_ConnectionQuality * Len(strMessage)) * (3 ^ m_FTTransferCounter) + 2 'Sek Sicherheitstimeout zum senden der Daten
tTime = Now
udtSocket(lngClassID).LastTraffic = Now
Do
    'Ret = udtSocket(lngClassID).cConnection.clsSocket_SendData(Left$(strMessage, m_SendBuffer - 1), strRemoteIP, bolBroadcast)
    Ret = udtSocket(lngClassID).cConnection.clsSocket_SendData(strMessage, strRemoteIP, bolBroadcast)
    DoEvents: Call Sleep(1)
    If Ret > 0 Then
        If Len(strMessage) > Ret Then
            strMessage = Mid$(strMessage, Ret + 1)
        Else
            strMessage = vbNullString
        End If
        Call SocketLog("Bytes sending: " & Ret & ", to: " & udtSocket(lngClassID).strUser & "\" & strRemoteIP, lngClassID, SOCKETLOG_INFO)
    ElseIf Ret = -1 Then
        'Socketerror
        Sleep 500
    ElseIf Ret = -2 Then
        'Connect error
        SocketSendMessage = -1
        Call SocketLog("Connecting faild to: " & strRemoteIP, lngClassID, SOCKETLOG_WARNING)
        Exit Do
    ElseIf Ret = -10 Then
        'Socket Error aufgetreten
        SocketSendMessage = -2
        Call SocketLog("SocketError while Sending", lngClassID, SOCKETLOG_WARNING)
        Exit Do
    Else
        Debug.Print "Not Send"
    End If
    If DateDiff("s", tTime, Now) > lngSendTime Then
        SocketSendMessage = -1
        Call SocketLog("Sending faild to: " & strRemoteIP, lngClassID & " Timeout expired", SOCKETLOG_WARNING)
        Exit Do
    End If
Loop While Len(strMessage) > 0

End Function

Private Function GetWaitingMessage(ByVal lngClassID As Long) As Long
Dim cHTTP As clsWinSockHTTP
Dim strMessage As String
Dim strRemoteIP As String

Set cHTTP = New clsWinSockHTTP
With cHTTP
    .Answer = False
    '.OverProxy = True
    .SocketCommand = PROXY_GET_MESSAGE
    strMessage = .GetHTTP_Packet
    strRemoteIP = udtSocket(lngClassID).strDestination
    If SocketSendMessage(strMessage, lngClassID, strRemoteIP) <> 1 Then DestroySocketClass lngClassID
End With
Set cHTTP = Nothing
End Function

Private Function SendWaitingMessage(ByVal lngClassID As Long) As Long
Dim cHTTP As clsWinSockHTTP
Dim strMessage As String
Dim strRemoteIP As String

If udtSocket(lngClassID).ProxyTransmissionInProgress = False Then Exit Function
Set cHTTP = New clsWinSockHTTP
With cHTTP
    .Answer = True
    .OverProxy = True
    If udtSocket(lngClassID).Buffer.SendBuffer.Count > 0 Then
        strMessage = udtSocket(lngClassID).Buffer.SendBuffer.Item(1)
        udtSocket(lngClassID).Buffer.SendBuffer.Remove (1)
    Else
        .SocketCommand = PROXY_NO_MORE_MESSAGE
        strMessage = .GetHTTP_Packet
    End If
    strRemoteIP = udtSocket(lngClassID).strDestination
    If SocketSendMessage(strMessage, lngClassID, strRemoteIP) <> 1 Then DestroySocketClass lngClassID
End With
udtSocket(lngClassID).ProxyTransmissionInProgress = False
Set cHTTP = Nothing
End Function

'wird spter mal korrigiert :-))
#If SocketDebug Then
   Public Sub CalculateFTSize(ByVal AddFT As Long)
#Else
   Private Sub CalculateFTSize(ByVal AddFT As Long)
#End If

Dim lngFTCount As Long
Dim lngTimeChange As Long
lngTimeChange = 29
'Die Function wird nicht erklrt ;-)
m_FTTransferCounter = m_FTTransferCounter + AddFT
lngFTCount = m_FTTransferCounter
If lngFTCount < 1 Then lngFTCount = 1
If m_ConnectionQuality = 0 Then m_ConnectionQuality = Modem
m_FTSendBuffer = Fix(m_ConnectionQuality / 8)
If m_FTSendBuffer > m_SendBuffer - 1 Then m_FTSendBuffer = m_SendBuffer - 1
If m_FTSendBuffer / lngFTCount < 500 Then
    m_FTSendMultipiller = (m_FTSendBuffer / m_ConnectionQuality * 1000 / lngTimeChange) * lngFTCount
Else
    m_FTSendMultipiller = (m_FTSendBuffer / m_ConnectionQuality * 1000 / lngTimeChange)
    m_FTSendBuffer = m_FTSendBuffer / lngFTCount
End If
End Sub
Private Function SendFiletransferConnectMe(strRemoteIP As String, cConnectionClass As Long) As Long
Dim cHTTP   As clsWinSockHTTP, strMSG As String

Set cHTTP = New clsWinSockHTTP
'Message zusammenbauen
cHTTP.SocketCommand = FILETRANSFER_RECONNECT
cHTTP.IP = strRemoteIP
strMSG = cHTTP.GetHTTP_Packet
Set cHTTP = Nothing
'Message senden
If SocketSendMessage(strMSG, cConnectionClass, strRemoteIP) = 1 Then
    SendFiletransferConnectMe = 1
Else
    SendFiletransferConnectMe = 0
    Call DestroySocketClass(cConnectionClass)
End If

End Function
Public Function clsWinSock_Filetransfer_Abort(strRemoteIP As String, _
                                          strUser As String) As Boolean
On Local Error Resume Next
Dim X       As Long
Dim lngFT   As Long
Dim cHTTP   As clsWinSockHTTP
'Normale Chatverbindung suchen
X = GetClassItem(strRemoteIP, strUser)
'Filetransferverbindung suchen
lngFT = GetClassItem(strRemoteIP, strUser, True)
If lngFT > m_MAX_SOCKET Then
    'Wenn keine Filetransfervverbindung gefunden wurde, dann ist auch nicht abzubrechen
    clsWinSock_Filetransfer_Abort = True
    Exit Function
End If

Set cHTTP = New clsWinSockHTTP
'Message zusammenbauen
With cHTTP
    .Answer = udtSocket(X).IncomingConnect
    .SocketCommand = FILETRANSFER_ABORT
    .Content_Type = "text/plain"
    .IP = strRemoteIP
    .Connection = "keep-alive"
End With
'If udtSocket(lngFT).bolFiletransferSending Then Call CalculateFTSize(-1)
'Verhindern das der Filetransfer weiter ausgefhrt wird
udtSocket(lngFT).bolFiletransferReciving = False
udtSocket(lngFT).bolFiletransferSending = False
udtSocket(lngFT).cConnection.FileTransferAbort = True
udtSocket(lngFT).CloseRquired = True

If X > m_MAX_SOCKET Then clsWinSock_Filetransfer_Abort = True: Exit Function
If SocketSendMessage(cHTTP.GetHTTP_Packet, X, strRemoteIP) = 1 Then
    clsWinSock_Filetransfer_Abort = True
Else
    'DoEvents
    Call DestroySocketClass(lngFT)
    Call DestroySocketClass(X)
    'DoEvents
End If

Set cHTTP = Nothing
End Function

Public Function clsWinSock_SendFile(ByVal strFilename As String, _
                                          strRemoteIP As String, _
                                          strUser As String, _
                                 Optional strSocketCommand As String = FILETRANSFER_WILL_STARTING) As Boolean
On Local Error Resume Next
Dim X       As Long
Dim cHTTP   As clsWinSockHTTP
Dim tTime   As Date

Set cHTTP = New clsWinSockHTTP

X = GetClassItem(strRemoteIP, strUser, True)
If X > m_MAX_SOCKET Then
    X = GetClassItem(strRemoteIP, strUser)
    If X > m_MAX_SOCKET Then
        Exit Function
    Else
        If udtSocket(X).IncomingConnect = True Then
            'Dem anderen die connection aufbauen lassen
            tTime = Now
            If SendFiletransferConnectMe(strRemoteIP, X) = 1 Then
                Do
                    Sleep 1
                    DoEvents
                    If strIncomingFileConnection = strRemoteIP Then Exit Do
                    If strIncomingFileConnection = "Faild" Then Exit Function
                    If CLng(DateDiff("s", tTime, Now)) > TIMEOUT_RECONNECT Then
                        Call SocketLog("RemoteHost hat kein FT Reconnect gemacht.", X, SOCKETLOG_WARNING_EX)
                        Exit Function
                    End If
                Loop
                strIncomingFileConnection = vbNullString
                X = GetClassItem(strRemoteIP, strUser, True)
            Else
                Exit Function
            End If
        Else
            'selbst die vebindung aufbauen
            X = CreateNewSocket
            Call SocketLog("Create new FT Socket fr " & strUser, X, SOCKETLOG_INFO)
            If X > m_MAX_SOCKET Then Exit Function
        End If
    End If
    
End If

If X > m_MAX_SOCKET Then Exit Function
udtSocket(X).bolFiletransfer = True
udtSocket(X).strDestination = strRemoteIP

With cHTTP
    .Answer = udtSocket(X).IncomingConnect
    .SocketCommand = strSocketCommand
    .SocketForwardTo = ""
    .Content_Type = "text/plain"
    If strSocketCommand = FILETRANSFER_WILL_STARTING Then
        .FileLength = FileLen(strFilename) + FILE_CRYPT_HEADER
        .FileName = Mid$(strFilename, InStrRev(strFilename, "\", , vbTextCompare) + 1)
    ElseIf strSocketCommand = FILETRANSFER_OK Then
        udtSocket(X).cConnection.FileName = strFilename
    End If
    .IP = strRemoteIP
    .Connection = "keep-alive"
End With

If SocketSendMessage(cHTTP.GetHTTP_Packet, X, strRemoteIP) = 1 Then
    clsWinSock_SendFile = True
    udtSocket(X).cConnection.FileName = strFilename
    If Not strSocketCommand = FILETRANSFER_OK Then udtSocket(X).cConnection.FileLength = cHTTP.FileLength
    udtSocket(X).strDestination = strRemoteIP
    udtSocket(X).strUser = strUser
Else
    Call DestroySocketClass(X)
End If

Set cHTTP = Nothing

End Function


Public Sub clsWinsock_StartListener()
Dim X As Long
If bolListen = True Then Exit Sub
'die erste freie Socketklasse suchen
X = GetFirstFreeClass
'Den ersten Listener erzeugen
Set udtSocket(X).cConnection = New clsSocket
'Klassenreferenz mitgeben, das ist sehr wichtig
udtSocket(X).cConnection.clsSocket_SetReferenz Me
udtSocket(X).cConnection.ClassIndex = X
SocketLog "CreateListenerClass", X, SOCKETLOG_INFO_EX
'Konnte ich Listen?

If udtSocket(X).cConnection.clsSocket_ListenPort = True Then
    'Ja es hat funktioniert, jetzt noch als belegt kennzeichnen
    udtSocket(X).inUse = True
    udtSocket(X).bolListen = True
    'Event auslsen
    RaiseEvent IsListen(True)
    'Mach mal kurz was anderes
    DoEvents
    bolListen = True
    Call SocketLog("Listen success!", X, SOCKETLOG_INFO_EX)
Else
    'Wie es hat nicht funktioniert
    udtSocket(X).cConnection.DestroySocket
    Set udtSocket(X).cConnection = Nothing
    udtSocket(X).IncomingConnect = False
    udtSocket(X).RecivingInProgress = False
    'Bescheidsagen mssen wir ja auch noch
    RaiseEvent IsListen(False)
    Call SocketLog("Listen faild!", X, SOCKETLOG_ERROR)
End If

End Sub

Public Function clsWinSock_Login(DataContainer As clsLoginData) As Boolean
'Debug.Print strLoginData
'Erstmal die Klasse erstellen
Set cLogin = New clsLogin
SocketLog "clsWinSock_Login", -1, SOCKETLOG_INFO
'Die Referenz brauchen wir hier auch
cLogin.clsLogin_SetReferenz Me
'Daten hin und zurck
clsWinSock_Login = cLogin.clsLogin_SendData(DataContainer)
'und wieder raus
Set cLogin = Nothing
'SocketLog clsWinSock_Login,-1, 1
End Function


Private Sub Class_Initialize()
Dim strBaseDir As String

c_lngPID = GetCurrentProcessId() 'PID ermitteln

strBaseDir = App.Path
If Right$(strBaseDir, 1) <> "\" Then strBaseDir = strBaseDir & "\"
Call MakeSureDirectoryPathExists(strBaseDir & "SocketLog")
c_SocketLogFile = strBaseDir & "\SocketLog\Log_"

ReDim udtSocket(0 To m_MAX_SOCKET)
Dim StartupData As WSADataType
Set cSocketWindow = New clsSocketWindow
'hTimer = SetTimer(0, 0, 20, AddressOf TimerProc)

Call WSACleanup
SocketLog vbCrLf & "WSAStartup", -1, SOCKETLOG_INFO
Call WSAStartup(&H101, StartupData)

End Sub

Private Sub Class_Terminate()

'Schmei mal alle Socken raus
On Error Resume Next
'KillTimer 0, hTimer
SocketLog "WSACleanup", -1, SOCKETLOG_INFO

Call WSACleanup
Call cSocketWindow.DestroyAndUnhook
Set cSocketWindow = Nothing
End Sub

Public Sub clsWinSock_UnloadAllWinSocket()
Set c_colSocket = Nothing
Call ClearAllConnection
bolListen = False
End Sub
Friend Function clsWinSock_IsClientRouted(ByVal strRemoteIP As String, ByVal strUsername As String) As ClientRoutingInfo
Dim X As Long
On Error GoTo ErrorHandler
clsWinSock_IsClientRouted = ClientIsNotRouted

For X = 0 To UBound(udtRoutingInfo)
    If udtRoutingInfo(X).strIP = strRemoteIP And _
       LCase$(udtRoutingInfo(X).strUser) = LCase$(strUsername) Then
        If udtRoutingInfo(X).lngClass > m_MAX_SOCKET Then
            If CLng(udtRoutingInfo(X).Broadcast) Then
                clsWinSock_IsClientRouted = ClientGatewayIsSearching
                Exit For
            Else
                clsWinSock_IsClientRouted = ClientHasNotGateway
                Exit For
            End If
        Else
            clsWinSock_IsClientRouted = ClientIsRouted
            Exit For
        End If
    End If
Next
Exit Function
ErrorHandler:
clsWinSock_IsClientRouted = ClientIsNotRouted
End Function

Private Sub ClearAllConnection()
Dim X As Long
'Und zwar eine nach der Anderen
SocketLog "ClearAllConnection", -1, SOCKETLOG_INFO

For X = 0 To m_MAX_SOCKET
    'udtSocket(X).cConnection.clsSocket_EndWinSock
    If Not udtSocket(X).cConnection Is Nothing Then
        udtSocket(X).cConnection.FileTransferAbort = True
        DoEvents
        If udtSocket(X).bolFiletransfer Then _
            udtSocket(X).cConnection.clsSocket_SendData CONNECTION_CLOSED, udtSocket(X).strDestination
        If udtSocket(X).bolListen Then
            Call SocketLog("Listener was terminated", X, SOCKETLOG_INFO_EX)
        Else
            Call SocketLog("Socket was terminated", X, SOCKETLOG_INFO_EX)
        End If
    End If
    Call DestroySocketClass(X)
    
Next
End Sub

Private Sub SocketLog(strDebugMessage As String, SocketClass As Long, lngLogLevel As SocketLogModeEnum)
Dim hFile As Integer
If lngLogLevel >= m_SocketLogLevel Then
    #If SocketDebug Then
        RaiseEvent DebugMessage("ClassID: [" & SocketClass & "]" & vbTab & strDebugMessage)
    #Else
        Debug.Print Now; " : "; strDebugMessage
    #End If
    
    hFile = FreeFile
    Open c_SocketLogFile & Weekday(Now, vbMonday) & "_PID_" & c_lngPID & ".log" For Append As #hFile
    If Left$(strDebugMessage, 2) = vbCrLf Then
        Print #hFile, vbNullString
        strDebugMessage = Mid$(strDebugMessage, 3)
    End If
    Print #hFile, Now & " - " & GetLogLevelString(lngLogLevel) & vbTab & _
                  " ClassID: [" & SocketClass & "] " & vbTab & _
                  " - " & strDebugMessage & vbCrLf;
    Close #hFile
End If
End Sub

Private Sub SocketLogSpeziale(strDebugMessage As String, UserName As String)
Dim hFile As Integer
    
    hFile = FreeFile
    Open c_SocketLogFile & "_" & UserName & ".log" For Append As #hFile
    If Left$(strDebugMessage, 2) = vbCrLf Then
        Print #hFile, vbNullString
        strDebugMessage = Mid$(strDebugMessage, 3)
    End If
    Print #hFile, Now & ":" & vbCrLf;
    Print #hFile, strDebugMessage & vbCrLf;
    
    Close #hFile
End Sub

'Private Sub ErrorLog(strFunction As String, strErrorMessage As String, SocketClass As Long)
'Dim hFile As Integer
'hFile = FreeFile
'    Open c_SocketLogFile & "Error.log" For Append As #hFile
'    If Left$(strErrorMessage, 2) = vbCrLf Then
'        Print #hFile, vbNullString
'        strErrorMessage = Mid$(strErrorMessage, 3)
'    End If
'    Print #hFile, Now & " - " & strFunction & vbTab & _
'                  " ClassID: [" & SocketClass & "] " & vbTab & _
'                  " - " & strErrorMessage & vbCrLf;
'    Close #hFile
'End Sub

Private Function GetLogLevelString(lngLogLevel As SocketLogModeEnum) As String
Select Case lngLogLevel
    Case SOCKETLOG_INFO: GetLogLevelString = "Info"
    Case SOCKETLOG_INFO_EX: GetLogLevelString = "InfoEX"
    Case SOCKETLOG_WARNING: GetLogLevelString = "Warning"
    Case SOCKETLOG_WARNING_EX: GetLogLevelString = "WarningEX"
    Case SOCKETLOG_ERROR: GetLogLevelString = "Error"
    Case SOCKETLOG_ERROR_EX: GetLogLevelString = "ErrorEX"
    Case Else: GetLogLevelString = "Unknow"
End Select
End Function
Private Sub DestroySocketClass(lngIndex As Long)
If Not udtSocket(lngIndex).cConnection Is Nothing Then
    If udtSocket(lngIndex).bolListen Then
        Call SocketLog("Destroy Listenerclass", lngIndex, SOCKETLOG_INFO_EX)
    Else
        Call SocketLog("Destroy Class", lngIndex, SOCKETLOG_INFO_EX)
    End If
    udtSocket(lngIndex).cConnection.DestroySocket
Else
    'Debug.Print "Clear UDT: "; lngIndex
End If
Set udtSocket(lngIndex).cConnection = Nothing
'Buffer lschen
Set udtSocket(lngIndex).Buffer.SendBuffer = Nothing
udtSocket(lngIndex).Buffer.DataBuffer = vbNullString
udtSocket(lngIndex).Buffer.DataRecived = 0
udtSocket(lngIndex).Buffer.DataSize = 0
udtSocket(lngIndex).Buffer.DataBufferCalc = False
'Filetransfervars zurcksetzen
udtSocket(lngIndex).bolFiletransferReciving = False
udtSocket(lngIndex).bolFiletransferSending = False
udtSocket(lngIndex).bolFiletransfer = False
'Allgemeine Vars zurcksetzen
udtSocket(lngIndex).ProxyConnection = False
udtSocket(lngIndex).ProxyTransmissionInProgress = False
udtSocket(lngIndex).IncomingConnect = False
udtSocket(lngIndex).inUse = False
udtSocket(lngIndex).RecivingInProgress = False
udtSocket(lngIndex).strDestination = vbNullString
udtSocket(lngIndex).strUser = vbNullString
udtSocket(lngIndex).CloseRquired = False

End Sub
Private Function FiletransferConnectHost(strRemoteIP As String, strSocketCommand As String, strUser As String) As Boolean
Dim X       As Long
Dim cHTTP   As clsWinSockHTTP

Set cHTTP = New clsWinSockHTTP
'Connection suchen
X = GetClassItem(strRemoteIP, strUser, True)
cHTTP.Answer = True
If X > m_MAX_SOCKET Then
    'wenn keine existierte, dann eine erstellen
    X = CreateNewSocket
    If X > m_MAX_SOCKET Then
        Call SocketLog("Cant Create FiletransferSocket fr " & strUser, X, SOCKETLOG_WARNING_EX)
        Exit Function
    Else
        Call SocketLog("Create FiletransferSocket fr " & strUser, X, SOCKETLOG_INFO_EX)
    End If
    cHTTP.Answer = False
End If
udtSocket(X).bolFiletransfer = True
cHTTP.IP = strRemoteIP
cHTTP.SocketCommand = strSocketCommand
'Packet senden
If SocketSendMessage(cHTTP.GetHTTP_Packet, X, strRemoteIP, True) = 1 Then
    FiletransferConnectHost = True
    udtSocket(X).bolFiletransfer = True
    udtSocket(X).strDestination = strRemoteIP
    udtSocket(X).strUser = strUser
Else
    Call DestroySocketClass(X)
End If
End Function


'***********************************************************************************************************
Public Sub HeartBeat()
On Local Error GoTo ErrorHandler
Dim X As Long, lngNewActiveConnection As Long
Static bolExit As Boolean
'Verhindern, das der Timer 2 mal durchluft
If bolExit Then Exit Sub
bolExit = True
'Beat alle 25ms

For X = 0 To m_MAX_SOCKET
    If udtSocket(X).inUse = True And udtSocket(X).bolListen = False Then
        If m_ProxyEnabled = True Then
            If DateDiff("s", udtSocket(X).ProxyLastSend, Now) > 15 And _
                udtSocket(X).bolFiletransferReciving = False And _
                udtSocket(X).bolFiletransferSending = False Then
                GetWaitingMessage X
                udtSocket(X).ProxyLastSend = Now
            End If
        End If
        If DateDiff("n", udtSocket(X).LastTraffic, Now) > CONNECTION_IDLE_TIME Then
            If lngActiveConnections > MIN_CONNECTIONS And udtSocket(X).bolFiletransfer = False Then
                lngActiveConnections = lngActiveConnections - 1
                RaiseEvent ClientDisconnected(udtSocket(X).strDestination, udtSocket(X).strUser)
                'udtSocket(X).cConnection.DestroySocket
                DestroySocketClass (X)
            End If
        Else
            If udtSocket(X).bolFiletransfer = False Then lngNewActiveConnection = lngNewActiveConnection + 1
        End If
        If udtSocket(X).bolFiletransferSending Then
            Select Case udtSocket(X).cConnection.SendFile
                Case -2 'Faild
                    udtSocket(X).bolFiletransferSending = False 'Nicht mehr im HearBeat behandeln
                    RaiseEvent FileTransferComplete(udtSocket(X).strDestination, _
                                                    udtSocket(X).strUser, _
                                                    udtSocket(X).cConnection.FileName, _
                                                    False, _
                                                    True)
                    Call SocketLog("Error beim Senden FT in Class", X, SOCKETLOG_ERROR)
                    'Call CalculateFTSize(-1)
                    Call DestroySocketClass(X) 'Klasse kann zerstrt werden
                Case -1 'Abort
                    udtSocket(X).bolFiletransferSending = False 'Nicht mehr im HearBeat behandeln
                    RaiseEvent FileTransferComplete(udtSocket(X).strDestination, _
                                                    udtSocket(X).strUser, _
                                                    udtSocket(X).cConnection.FileName, _
                                                    True, _
                                                    False)
                    'Call CalculateFTSize(-1)
                    Call DestroySocketClass(X) 'Klasse kann zerstrt werden
                Case 0 'fertig
                    udtSocket(X).bolFiletransferSending = False 'Nicht mehr im HearBeat behandeln
                    RaiseEvent FileTransferComplete(udtSocket(X).strDestination, _
                                                    udtSocket(X).strUser, _
                                                    udtSocket(X).cConnection.FileName, _
                                                    False, _
                                                    False)
                    'Call CalculateFTSize(-1)
                    'Die Klasse darf nicht zerstrt werden, das macht der Empfnger
                Case 1
                    'geht weiter
            End Select
        ElseIf udtSocket(X).bolFiletransferReciving Then
            'Reciving
            Select Case udtSocket(X).cConnection.ReciveFile
                Case -2 'Faild
                    RaiseEvent FileTransferComplete(udtSocket(X).strDestination, _
                                                    udtSocket(X).strUser, _
                                                    udtSocket(X).cConnection.FileName, _
                                                    False, _
                                                    True)
                    Call SocketLog("Error beim Empfang FT in Class", X, SOCKETLOG_ERROR)
                    'Call CalculateFTSize(-1)
                    Call DestroySocketClass(X) 'Klasse kann zerstrt werden
                Case -1 'Abort
                    udtSocket(X).bolFiletransferReciving = False 'Nicht mehr im HearBeat behandeln
                    RaiseEvent FileTransferComplete(udtSocket(X).strDestination, _
                                                    udtSocket(X).strUser, _
                                                    udtSocket(X).cConnection.FileName, _
                                                    True, _
                                                    False)
                    'Call CalculateFTSize(-1)
                    Call DestroySocketClass(X) 'Klasse kann zerstrt werden
                Case 0 'fertig
                    udtSocket(X).bolFiletransferReciving = False 'Nicht mehr im HearBeat behandeln
                    RaiseEvent FileTransferComplete(udtSocket(X).strDestination, _
                                                    udtSocket(X).strUser, _
                                                    udtSocket(X).cConnection.FileName, _
                                                    False, _
                                                    False)
                    'Call CalculateFTSize(-1)
                    Call DestroySocketClass(X) 'Klasse kann zerstrt werden
                Case 1
                    'geht weiter
                    'Nothing todo
            End Select
        End If
    End If
Next

lngActiveConnections = lngNewActiveConnection

On Local Error GoTo ErrorHandler2

For X = 0 To UBound(udtRoutingInfo)
    'in Broadcast steht ein Wert drin, wenn ein Gateway automatisch gesucht wird
    'automatisch wird nur gesucht, wenn das vorhandene Gateway sich abgemeldet hat
    If CLng(udtRoutingInfo(X).Broadcast) Then
        'Ist in der Zwischenzeit an anderer Client als Gateway bereit, dann ist lngClass <= m_MAX_SOCKET
        If udtRoutingInfo(X).lngClass > m_MAX_SOCKET Then
            'Nach 2 Sekunden ist nicht mehr mit einer Meldung zu rechnen
            If CLng(DateDiff("s", udtRoutingInfo(X).Broadcast, Now)) > 2 Then
                udtRoutingInfo(X).Broadcast = 0
                RaiseEvent GatewayConnectionHasLost(udtRoutingInfo(X).strIP, udtRoutingInfo(X).strUser)
            End If
        Else
            'Neues Gateway ist bekannt und kann benutzt werden
            udtRoutingInfo(X).Broadcast = 0
            RaiseEvent GatewayFoundByBroadcast(udtRoutingInfo(X).strIP, udtRoutingInfo(X).strUser)
        End If
    End If
Next
bolExit = False
Exit Sub

ErrorHandler:
Call DestroySocketClass(X)
Resume Next

ErrorHandler2:
'Hier muss nicht weiter gearbeitet werden
bolExit = False
End Sub

