Attribute VB_Name = "modSubClass"
Option Explicit

Private Const GWL_WNDPROC As Long = -4
Public Const FD_READ As Long = 1
Public Const FD_WRITE As Long = 2
Public Const FD_OOB As Long = 4
Public Const FD_ACCEPT As Long = 8
Public Const FD_CONNECT As Long = &H10&
Public Const FD_CLOSE As Long = &H20&

'**********************************************************************************
'* Window API's
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function IsWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Public Declare Function CreateWindowEx Lib "user32.dll" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Public Declare Function DestroyWindow Lib "user32.dll" (ByVal hwnd As Long) As Long
Public Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)

'********************************************************************************
'* Timer API's
Private Declare Function SetTimer Lib "user32.dll" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Private Declare Function KillTimer Lib "user32.dll" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long

Private m_colInterfaces As New Collection   'Collection mit den Interfacereferenzen
Private m_colOldWndProc As New Collection   'Collection mit den Originalen WndProc's und Timerhandles

Public Function SetTimerForBuffer(objRef As iSocketSubClass) As Long
'Dim cInterface As iSubClass
On Local Error Resume Next

'Set cInterface = m_colInterfaces("hTimer" & lnghWnd)
'If cInterface Is Nothing Then
    Debug.Print "Timer Create"
    'Timer erstellen
    SetTimerForBuffer = SetTimer(0, 0, 10, AddressOf TimerProc)
    'Interfacereferenz merken
    m_colInterfaces.Add objRef, "hTimer" & SetTimerForBuffer
    'Timerhandle merken
    m_colOldWndProc.Add SetTimerForBuffer, "hTimer" & SetTimerForBuffer
'End If
'Set cInterface = Nothing
End Function
Public Function KillTimerForBuffer(ByVal hTimer As Long) As Long
On Local Error Resume Next
'Dim lnghTimer As Long
'lnghTimer = m_colOldWndProc("hTimer" & hTimer)
Call KillTimer(0, hTimer)                  'Timer lschen
m_colOldWndProc.Remove ("hTimer" & hTimer) 'Handle lschen
m_colInterfaces.Remove ("hTimer" & hTimer) 'Interfacereferenz lschen
End Function

Public Function SetSubClass(ByVal lnghWnd As Long, objRef As iSocketSubClass) As Long
Dim cInterface As iSocketSubClass
Dim lngOldProc As Long
On Local Error Resume Next
'Prfen ob dieses Fenster schon einem Interface zugeordnet ist
Set cInterface = m_colInterfaces("hWnd" & lnghWnd)
If Not cInterface Is Nothing Then
    SetSubClass = -1 'Fenster hat schon ein Interface, kann nicht nochmal bearbeitet werden
Else
    If IsWindow(lnghWnd) Then 'Prfen ob das Handle ein Fenster ist
        'WndProc ersetzen, allgemein Subclassen genannt
        lngOldProc = SetWindowLong(lnghWnd, GWL_WNDPROC, AddressOf WndProc)
        m_colOldWndProc.Add lngOldProc, "hWnd" & lnghWnd 'Originale WndProc merken
        m_colInterfaces.Add objRef, "hWnd" & lnghWnd 'Inerface dazu merken
        objRef.OldWndProc = lngOldProc 'Originale WndProc ins Interface bertragen
        SetSubClass = 1 'Es hat funktioniert
    Else
        'Kein Fenster
    End If
End If
Set cInterface = Nothing 'vorhandene Referenz freigeben
End Function

Public Sub UnSetSubClass(ByVal lnghWnd As Long)
Dim lngOldProc As Long
On Local Error Resume Next
'Originale WndProc auslesen
lngOldProc = m_colOldWndProc("hWnd" & lnghWnd)
If lngOldProc Then 'Wenn eine bekannt war, dann wiederherstellen
    Call SetWindowLong(lnghWnd, GWL_WNDPROC, lngOldProc)
    'Originale WndProc lschen
    m_colOldWndProc.Remove ("hWnd" & lnghWnd)
    'Interface dazu lschen
    m_colInterfaces.Remove ("hWnd" & lnghWnd)
End If
End Sub
'*****************************************************************************
'* WndProc
'*****************************************************************************
Public Function WndProc(ByVal m_hwnd As Long, ByVal m_uMsg As Long, ByVal m_wParam As Long, ByVal m_lParam As Long) As Long
Dim m_Interface As iSocketSubClass
Dim lngOldProc As Long
Debug.Print "Entry in modWndProc, hWnd: "; m_hwnd; ""
'Unsere WndProc die von Windows aufgerufen wird
On Local Error GoTo InterfaceErrorHandler
'original WndProc auslesen
lngOldProc = m_colOldWndProc("hWnd" & m_hwnd)
'zuerst die Interfacereferenz setzen, damit wir die WndProc weiterleiten knnen
Set m_Interface = m_colInterfaces("hWnd" & m_hwnd)
'WndProc weiter durch das Interface leiten
WndProc = m_Interface.WndMsg(m_hwnd, m_uMsg, m_wParam, m_lParam)
Set m_Interface = Nothing 'Referenz des Interface lschen
'Wenn ein Fehler im Interface aufgetreten ist, dann kann es erforderlich sein
'die Originale WndProc von hier anzuspringen
If WndProc = -1 And lngOldProc <> 0 Then WndProc = CallWindowProc(lngOldProc, m_hwnd, m_uMsg, m_wParam, m_lParam)
Exit Function
InterfaceErrorHandler:
'Hier knnte man auch unsubclassen, da das Interface nicht mehr da ist.
On Local Error Resume Next
Debug.Print "Error in modWndProc, hWnd: "; m_hwnd
'Bei einem Fehler einfach die Nachricht weiterleiten
If lngOldProc <> 0 Then WndProc = CallWindowProc(lngOldProc, m_hwnd, m_uMsg, m_wParam, m_lParam)
Set m_Interface = Nothing
End Function

'******************************************************************************
'* TimerProc
'******************************************************************************
Public Sub TimerProc(ByVal m_hwnd As Long, ByVal m_uMsg As Long, ByVal m_idEvent As Long, ByVal m_dwTime As Long)
Dim m_Interface As iSocketSubClass
On Local Error GoTo InterfaceErrorHandler
'Interface ermitteln
Set m_Interface = m_colInterfaces("hTimer" & m_idEvent)
'TimerProc ins Interface leiten
Call m_Interface.TimerProc(m_hwnd, m_uMsg, m_idEvent, m_dwTime)
'raus aus der Sub
Exit Sub
InterfaceErrorHandler:
'Hier ist ein Fehler beim Interfaceaufruf aufgetreten. Darum ist es sicherer
'den Timer hier gleich zu disablen
On Error Resume Next
Call KillTimer(0, m_idEvent)  'Timer lschen
m_colInterfaces.Remove ("hTimer" & m_idEvent) 'falls vorhanden, das Interface lschen
m_colOldWndProc.Remove ("hTimer" & m_idEvent) 'falls vorhanden, das Timerhandle lschen
Set m_Interface = Nothing
End Sub

