VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAbsenceCheck"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINTAPI) As Long

Private Type POINTAPI
   X As Long
   Y As Long
End Type

Dim m_CntTimerEvent As Long
Dim m_MemOnlineState As Long
Dim m_AutoAwayActive As Boolean
Dim m_AwayTime As Long
Dim m_LongAwayTime As Long
Dim m_MousePointer As POINTAPI
Dim m_LastUserInputTime As Date
Dim m_Enabled As Boolean

Private Sub Class_Initialize()
   Call LoadSettings
   m_AutoAwayActive = False
   m_MemOnlineState = -99
End Sub

Public Sub LoadSettings()
   m_AwayTime = CLng(modSettings.GetSetting("AwaySys", "Away")) * 60 'sec
   m_LongAwayTime = CLng(modSettings.GetSetting("AwaySys", "LongAway")) * 60 'sec
   m_Enabled = CBool(CLng(modSettings.GetSetting("AwaySys", "Active")))
End Sub

Public Property Let Enabled(Value As Long)
   m_Enabled = Value
End Property
Public Property Get Enabled() As Long
   Enabled = m_Enabled
End Property

Public Property Get IsAwayTime() As Boolean
   IsAwayTime = (DateDiff("s", m_LastUserInputTime, Now) >= m_AwayTime)
End Property
Public Property Get IsLongAwayTime() As Boolean
   IsLongAwayTime = (DateDiff("s", m_LastUserInputTime, Now) >= m_LongAwayTime)
End Property

Public Property Let MemOnlineState(Value As Long)
   m_MemOnlineState = Value
End Property
Public Property Get MemOnlineState() As Long
   MemOnlineState = m_MemOnlineState
End Property

Public Property Let CntTimerEvent(Value As Long)
   m_CntTimerEvent = Value
End Property
Public Property Get CntTimerEvent() As Long
   CntTimerEvent = m_CntTimerEvent
End Property

Public Property Let AutoAwayActive(Value As Boolean)
   m_AutoAwayActive = Value
End Property
Public Property Get AutoAwayActive() As Boolean
   AutoAwayActive = m_AutoAwayActive
End Property

Public Function CheckUserInput() As Boolean
   Dim IsMouseMove As Boolean
   Dim IsKeyPress As Boolean
   Dim curMousePointer As POINTAPI
   
   'check mouse'
   Call GetCursorPos(curMousePointer)
   IsMouseMove = (m_MousePointer.X <> curMousePointer.X Or m_MousePointer.Y <> curMousePointer.Y)
   Call GetCursorPos(m_MousePointer)
   
   'check keys'
   IsKeyPress = False
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(1))  'left mouse
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(2))  'right mouse
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(8))  'backspace
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(13)) 'return
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(16)) 'shift
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(17)) 'ctrl
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(27)) 'escape
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(33)) 'page up
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(34)) 'page down
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(35)) 'end
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(36)) 'pos1
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(37)) 'left
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(38)) 'up
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(39)) 'right
   IsKeyPress = IsKeyPress Or CBool(GetAsyncKeyState(40)) 'down
   
   If IsMouseMove Or IsKeyPress Then
      CheckUserInput = True
      m_LastUserInputTime = Now
   Else
      CheckUserInput = False
   End If
   
End Function
