Attribute VB_Name = "modFileSystem"
Option Explicit

Public Function GetOnlyFilename(Text As String) As String
   Dim posStart As Long
   posStart = InStrRev(Text, "\")
   GetOnlyFilename = Mid$(Text, posStart + 1)
End Function

Public Function GetFileExtension(FileName As String) As String
   On Local Error Resume Next
   Dim StartPos As Long
   GetFileExtension = ""
   StartPos = InStrRev(FileName, ".")
   If StartPos > 0 Then
      GetFileExtension = LCase$(Mid$(FileName, StartPos + 1))
   Else
      GetFileExtension = ""
   End If
End Function

Public Function CorrectPath(Text As String) As String
   CorrectPath = Text & "\"
   CorrectPath = Replace(CorrectPath, "/", "\")
   CorrectPath = Replace(CorrectPath, "\\", "\")
End Function

Public Function CorrectFilename(Text As String) As String
   CorrectFilename = Text
   CorrectFilename = Replace(CorrectFilename, "/", "_")
   CorrectFilename = Replace(CorrectFilename, "\", "_")
   CorrectFilename = Replace(CorrectFilename, ":", "_")
   CorrectFilename = Replace(CorrectFilename, "*", "_")
   CorrectFilename = Replace(CorrectFilename, "?", "_")
   CorrectFilename = Replace(CorrectFilename, Chr$(34), "_")
   CorrectFilename = Replace(CorrectFilename, "<", "_")
   CorrectFilename = Replace(CorrectFilename, ">", "_")
   CorrectFilename = Replace(CorrectFilename, "|", "_")

End Function

Public Function FileExists(strPath As String) As Boolean
    On Error Resume Next
    FileExists = ((GetAttr(strPath) And (vbDirectory Or vbVolume)) = 0)
End Function

Public Function FolderExists(strPath As String) As Boolean
    On Error Resume Next
    FolderExists = ((GetAttr(strPath) And (vbDirectory)) = vbDirectory)
End Function

Public Function MakeSureDirectoryPathExists(Path As String) As Boolean
    ' Added by KonRad 14/06/2004 10:25 as a replacement for the API
    Dim Tokens()        As String
    Dim QualifiedPath   As String
    Dim Share           As String 'Added by Kai 29.10.2005
    Dim UNCPath         As String 'Added by Kai 29.10.2005
    Dim UNC             As Long
    Dim CurrToken       As Long
    
    On Error GoTo ERR_MakeSureDirectoryPathExists
    
    Path = Replace$(Path, "/", "\")
    UNC = IsUNC(Path, Share, UNCPath)
    If UNC = 1 Then 'UNC Path is Invalid!!
        Exit Function
    ElseIf UNC = -1 Then 'UNC is valid
        If LenB(UNCPath) Then
            Tokens = Split(UNCPath, "\")
        Else
            MakeSureDirectoryPathExists = FolderExists(Share)
            Exit Function
        End If
    ElseIf UNC = 0 Then 'Path is not UNC
        Tokens = Split(Path, "\")
        CurrToken = 1
        QualifiedPath = Tokens(0)
    Else 'Invalid Returnvalue
        Exit Function
    End If
    
    Do While CurrToken <= UBound(Tokens)
        If Len(Tokens(CurrToken)) = 0 Then
            Exit Do
        End If
        
        QualifiedPath = QualifiedPath & "\" & Tokens(CurrToken)
        Debug.Print Share & QualifiedPath
        If Not FolderExists(Share & QualifiedPath) Then
            Call MkDir(Share & QualifiedPath)
        End If
        
        CurrToken = CurrToken + 1
    Loop
    
    MakeSureDirectoryPathExists = True

Exit Function
ERR_MakeSureDirectoryPathExists:
Debug.Print "ERR_MakeSureDirectoryPathExists: "; Err.Description
End Function

'Ret 0 = Path is non UNC
'Ret -1 = Path is UNC and valid
'Ret 1 = Path is UNC and invalid
Private Function IsUNC(Path As String, Optional Share As String, Optional UNCPath As String) As Long
Dim Pos As Long
 'Added by Kai 29.10.2005
Path = PrepareExtendPath(Path)
If LeftB$(Path, 4) = "\\" Then
    Pos = InStrB(6, Path, "\")
    If Pos = 0 Or LenB(Path) <= Pos Then IsUNC = 1: Exit Function
    Pos = InStrB(Pos + 2, Path, "\")
    If Pos = 0 Then Pos = LenB(Path) 'Share only
    Share = LeftB$(Path, Pos - IIf(MidB$(Path, Pos, 2) = "\", 1, 0))
    UNCPath = MidB$(Path, Pos + 2)
    IsUNC = -1
End If
End Function

Public Function PrepareExtendPath(Path As String) As String
 'Added by Kai 29.10.2005
Const UNICODEPATH As String = "\\?\UNC\"
Const UNICODEPATHLEN As Long = 16
Const ANSICODEPATH As String = "\\?\"
Const ANSICODEPATHLEN As Long = 8

'Test on Extend-UNC-Path
If UCase$(LeftB$(Path, UNICODEPATHLEN)) = UNICODEPATH Then
    PrepareExtendPath = "\\" & MidB$(Path, UNICODEPATHLEN + 1)
Else
    'Test on Extend-local-Path
    If LeftB$(Path, ANSICODEPATHLEN) = ANSICODEPATH Then
        PrepareExtendPath = MidB$(Path, ANSICODEPATHLEN + 1)
    Else
        'Path is not Extend
        PrepareExtendPath = Path
    End If
End If
    
End Function
