Attribute VB_Name = "modWinXPStyles"
Option Explicit

Private Const PRF_CLIENT As Long = &H4&
Private Const PRF_ERASEBKGND As Long = &H8&
Private Const PRF_NONCLIENT As Long = &H2&
Private Const WS_CHILD As Long = &H40000000
Private Const TRANSPARENT As Long = 1

Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function ScreenToClient Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function ChildWindowFromPointEx Lib "user32.dll" (ByVal hWndParent As Long, ByVal px As Long, ByVal py As Long, ByVal uFlags As Long) As Long
Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function CreateCompatibleBitmap Lib "gdi32.dll" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function CreatePatternBrush Lib "gdi32.dll" (ByVal hBitmap As Long) As Long
Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hdc As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hwnd As Long, ByVal hdc As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long
Private Declare Function SetBkMode Lib "gdi32.dll" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function MapWindowPoints Lib "user32.dll" (ByVal hwndFrom As Long, ByVal hwndTo As Long, ByRef lppt As Any, ByVal cPoints As Long) As Long
Private Declare Function SetBrushOrgEx Lib "gdi32.dll" (ByVal hdc As Long, ByVal nXOrg As Long, ByVal nYOrg As Long, ByVal lppt As Long) As Long
Private Declare Function CreateRectRgn Lib "gdi32" (ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CombineRgn Lib "gdi32" (ByVal hDestRgn As Long, ByVal hSrcRgn1 As Long, ByVal hSrcRgn2 As Long, ByVal nCombineMode As Long) As Long
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetWindowRgn Lib "user32" (ByVal hwnd As Long, ByVal hRgn As Long, ByVal bRedraw As Long) As Long

Public m_hBrush As Long

Public Function StringPtr(String1 As String) As Long
    If String1 = "" Then
        StringPtr = 0
    Else
        StringPtr = StrPtr(String1)
    End If
End Function

Public Sub MakePictureBoxTransparent(cPicture As PictureBox, Optional xT As Long = 0, Optional yT As Long = 0)
    Dim lngHeight As Long
    Dim lngWidth As Long
    Dim lngRegion As Long
    Dim lngSecondRegion As Long
    Dim lStart As Long
    Dim lngRow As Long
    Dim lngCol As Long
    Dim lngBackColor As Long
    lngRegion = CreateRectRgn(0, 0, 0, 0)
    With cPicture
        lngHeight = .Height / m_lngTwipsPerPixelY - 1
        lngWidth = .Width / m_lngTwipsPerPixelX - 1
        lngBackColor = GetPixel(.hdc, xT, yT)
        For lngRow = 0 To lngHeight
            lngCol = 0
            Do While lngCol < lngWidth
                Do While lngCol < lngWidth And GetPixel(.hdc, lngCol, lngRow) = lngBackColor
                    lngCol = lngCol + 1
                Loop
                If lngCol < lngWidth Then
                    lStart = lngCol
                    Do While lngCol < lngWidth And GetPixel(.hdc, lngCol, lngRow) <> lngBackColor
                        lngCol = lngCol + 1
                    Loop
                    If lngCol > lngWidth Then lngCol = lngWidth
                    lngSecondRegion = CreateRectRgn(lStart, lngRow, lngCol, lngRow + 1)
                    Call CombineRgn(lngRegion, lngRegion, lngSecondRegion, 2)
                    Call DeleteObject(lngSecondRegion)
                End If
            Loop
        Next lngRow
    End With
    Call SetWindowRgn(cPicture.hwnd, lngRegion, 1)
End Sub

'Macht Controls die auf der TabStrip platziert werden transparent
'(geht nicht bei PictureBoxen; bentigt fr XP Styles)
Public Sub UpdateBackgroundBrush(ByVal Handle As Long, ByVal hdc As Long)
    Dim rc As RECT
    Dim lhDC As Long
    Dim hDCMem As Long
    Dim hBitmap As Long
    Dim hBmpOld As Long
    Dim p As POINTAPI
    Dim lngParent As Long

    If m_hBrush <> 0 Then
        DeleteObject m_hBrush
        m_hBrush = 0
    End If

    If ThemeActive Then
        Call GetWindowRect(Handle, rc)
        p.X = (rc.Right) + 1
        p.Y = (rc.Bottom) + 1
        ScreenToClient GetTopParent(Handle), p
        'Handle vom drunterliegenden Control ermitteln
        lngParent = ChildWindowFromPointEx(GetTopParent(Handle), p.X, p.Y, &H1)
        If lngParent <> 0 And GetWindowLong(lngParent, GWL_STYLE) And WS_CHILD Then
            Call GetWindowRect(lngParent, rc)
            lhDC = GetDC(lngParent)
            hDCMem = CreateCompatibleDC(lhDC)
            hBitmap = CreateCompatibleBitmap(lhDC, rc.Right - rc.Left, rc.Bottom - rc.Top)
            hBmpOld = SelectObject(hDCMem, hBitmap)
            SendMessage lngParent, WM_PRINTCLIENT, hDCMem, ByVal (PRF_ERASEBKGND Or PRF_CLIENT Or PRF_NONCLIENT)
            m_hBrush = CreatePatternBrush(hBitmap)
            hBitmap = SelectObject(hDCMem, hBmpOld)
            DeleteObject hBitmap
            DeleteDC hDCMem
            ReleaseDC lngParent, lhDC
        Else
            m_hBrush = CreateSolidBrush(TranslateColor(dlgMain.BackColor))
        End If
    Else
        m_hBrush = CreateSolidBrush(TranslateColor(dlgMain.BackColor))
    End If
    
    If ThemeActive Then
        Call GetWindowRect(Handle, rc)
        p.X = (rc.Right) + 3
        p.Y = (rc.Bottom) + 3
        ScreenToClient GetTopParent(Handle), p
        lngParent = ChildWindowFromPointEx(GetTopParent(Handle), p.X, p.Y, &H1)
        SetBkMode hdc, TRANSPARENT
        Call GetWindowRect(Handle, rc)
        MapWindowPoints 0&, lngParent, rc, 2
        SetBrushOrgEx hdc, -rc.Left, -rc.Top, 0
    End If

End Sub

Public Sub DeleteBackgroundBrush()
    If m_hBrush <> 0 Then
        DeleteObject m_hBrush
    End If
End Sub
